// VaxHashText.cpp: implementation of the CCodec class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VaxHashText.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


CVaxHashTextData::CVaxHashTextData()
{

}

CVaxHashTextData::~CVaxHashTextData()
{

}


////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

CVaxHashText::CVaxHashText()
{
	m_pDataList = new CHashTextDataList();
	m_pDataList->InitHashTable(16, TRUE);
}

CVaxHashText::CVaxHashText(LONG nSize)
{
	m_pDataList = new CHashTextDataList();
	m_pDataList->InitHashTable(nSize, TRUE);
}

CVaxHashText::~CVaxHashText()
{
	DeleteAll();

	delete m_pDataList;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

CString CVaxHashText::GenKey(CString sValue)
{
	sValue.MakeLower();
	return sValue;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

void CVaxHashText::AddData(LPCTSTR sName, CVaxHashTextData* pData)
{
	CString sKey = GenKey(sName);
	m_pDataList->SetAt(sKey, pData);
}

void CVaxHashText::DeleteData(LPCTSTR sName)
{
	CString sKey = GenKey(sName);
	CVaxHashTextData* pData = NULL;
	
	 if(!m_pDataList->Lookup(sKey, pData))
		 return;

	m_pDataList->RemoveKey(sKey);
	delete pData;
}

void CVaxHashText::RemoveData(LPCTSTR sName)
{
	CString sKey = GenKey(sName);
	m_pDataList->RemoveKey(sKey);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

CVaxHashTextData* CVaxHashText::FindData(LPCTSTR sName)
{
	CString sKey = GenKey(sName);
	CVaxHashTextData* pData = NULL;

	if(!m_pDataList->Lookup(sKey, pData))
		 return NULL;

	return pData;
}

BOOL CVaxHashText::IsExistData(LPCTSTR sName)
{
	CString sKey = GenKey(sName);
	CVaxHashTextData* pData = NULL;

	return m_pDataList->Lookup(sKey, pData);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

void CVaxHashText::GetNameAll(CStringList& objList)
{
	objList.RemoveAll();

	CVaxHashTextData* pData = NULL;
	CString sKey;
	
	for(POSITION hPos = m_pDataList->GetStartPosition(); hPos != NULL;)
	{
		m_pDataList->GetNextAssoc(hPos, sKey, pData);
		objList.AddTail(pData->m_sName);
	}
}

void CVaxHashText::DeleteAll()
{
	CVaxHashTextData* pData = NULL;
	CString sKey;
	
	for(POSITION hPos = m_pDataList->GetStartPosition(); hPos != NULL;)
	{
		m_pDataList->GetNextAssoc(hPos, sKey, pData);
		delete pData;
	}

	m_pDataList->RemoveAll();
}

void CVaxHashText::RemoveAll()
{
	m_pDataList->RemoveAll();
}