#pragma once
#include "afxwin.h"

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

#define SIP_DEFAULT_PORT								5060

#define VAX_ROUTE_TYPE_USER								0
#define VAX_ROUTE_TYPE_LINE								1
#define VAX_ROUTE_TYPE_QUEUE							2
#define VAX_ROUTE_TYPE_RING_GROUP						3
#define VAX_ROUTE_TYPE_CALL_PICKUP						4
#define VAX_ROUTE_TYPE_ROOM								5
#define VAX_ROUTE_TYPE_CALL_PARK						6
#define VAX_ROUTE_TYPE_STEALTH_LISTEN					7

#define VAX_PEER_TYPE_USER								0
#define VAX_PEER_TYPE_LINE								1

#define VAX_LINE_TYPE_UDP								0
#define VAX_LINE_TYPE_TCP								1
#define VAX_LINE_TYPE_TLS								2

#define VAX_REC_MUTE_TYPE_NONE							-1
#define VAX_REC_MUTE_TYPE_SPEAK							0
#define VAX_REC_MUTE_TYPE_LISTEN						1
#define VAX_REC_MUTE_TYPE_BOTH							2
        
///////////////////////////////////////////////////////////

#define VAX_CALL_CHANNEL_ZERO							0
#define VAX_CALL_CHANNEL_ONE							1

///////////////////////////////////////////////////////////

#define VAX_DTMF_TYPE_RFC2833							0
#define VAX_DTMF_TYPE_SIP_INFO							1
#define VAX_DTMF_TYPE_INBAND							2

#define VAX_PLAY_WAVE_MODE_EXCLUSIVE					0
#define VAX_PLAY_WAVE_MODE_MIXED						1

#define VAX_CODEC_GSM610								0
#define VAX_CODEC_ILBC									1
#define VAX_CODEC_G711A									2
#define VAX_CODEC_G711U									3
#define VAX_CODEC_G729									4

#define VAX_CODEC_TOTAL_COUNT							5

///////////////////////////////////////////////////////////

#define VAX_TRANSFER_TYPE_BLIND							0
#define VAX_TRANSFER_TYPE_CONSULT						1

///////////////////////////////////////////////////////////

#define VAX_STEALTH_LISTENER_FREE						0
#define VAX_STEALTH_LISTENER_BUSY						1

/////////////////////////////////////////////////////////

#define VAX_CUSTOM_HEADER_REQ_ID_INVITE					0

/////////////////////////////////////////////////////////

#define VAX_QUEUE_PROCESS_MODE_RING_ALL					0
#define VAX_QUEUE_PROCESS_MODE_HUNT_RANDOM				1
#define VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN				2
#define VAX_QUEUE_PROCESS_MODE_LEAST_ANSWERED			3
#define VAX_QUEUE_PROCESS_MODE_LEAST_TALK_TIME			4
#define VAX_QUEUE_PROCESS_MODE_LONGEST_WAITING			5
#define VAX_QUEUE_PROCESS_MODE_PRIORITIZED_HUNT			6

#define VAX_QUEUE_PROCESS_TYPE_FREE						0
#define VAX_QUEUE_PROCESS_TYPE_ANY						1

#define VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC			0
#define VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_RING				1

#define VAX_QUEUE_AGENT_AVAILABLE_STATUS				0
#define VAX_QUEUE_AGENT_UNAVAILABLE_STATUS				1

/////////////////////////////////////////////////////////

#define VAX_RING_GROUP_PROCESS_MODE_RING_ALL			0
#define VAX_RING_GROUP_PROCESS_MODE_HUNT_RANDOM			1
#define VAX_RING_GROUP_PROCESS_MODE_ROUND_ROBIN			2
#define VAX_RING_GROUP_PROCESS_MODE_LEAST_ANSWERED		3
#define VAX_RING_GROUP_PROCESS_MODE_LEAST_TALK_TIME		4
#define VAX_RING_GROUP_PROCESS_MODE_LONGEST_WAITING		5
#define VAX_RING_GROUP_PROCESS_MODE_PRIORITIZED_HUNT	6

#define VAX_RING_GROUP_PROCESS_TYPE_FREE				0
#define VAX_RING_GROUP_PROCESS_TYPE_ANY					1
                
/////////////////////////////////////////////////////////

#define VAX_CLOSED_REASON_CODE_HANGUP					0
#define VAX_CLOSED_REASON_CODE_SESSION_LOST				1
#define VAX_CLOSED_REASON_CODE_MOVED					2
#define VAX_CLOSED_REASON_CODE_TRANSFERED				3
#define VAX_CLOSED_REASON_CODE_REJECTED					4
#define VAX_CLOSED_REASON_CODE_FAILED					5
#define VAX_CLOSED_REASON_CODE_CANCELLED				6
#define VAX_CLOSED_REASON_CODE_TIMEOUT					7
#define VAX_CLOSED_REASON_CODE_CLOSED				    8

/////////////////////////////////////////////////////////

#define VAX_ACCESS_PCM_TYPE_ALL_NONE			-1
#define VAX_ACCESS_PCM_TYPE_EVENT_NONE			0
#define VAX_ACCESS_PCM_TYPE_EVENT_OUTBOUND		1
#define VAX_ACCESS_PCM_TYPE_EVENT_INBOUND		2
#define VAX_ACCESS_PCM_TYPE_EVENT_BOTH			3
#define VAX_ACCESS_PCM_TYPE_PIPE_NONE			4
#define VAX_ACCESS_PCM_TYPE_PIPE_OUTBOUND		5
#define VAX_ACCESS_PCM_TYPE_PIPE_INBOUND		6

/////////////////////////////////////////////////////////

#define VAX_MEDIA_FLOW_TYPE_SEND_RECV					0
#define VAX_MEDIA_FLOW_TYPE_SEND_ONLY					1
#define VAX_MEDIA_FLOW_TYPE_RECV_ONLY					2
#define VAX_MEDIA_FLOW_TYPE_INACTIVE					3

/////////////////////////////////////////////////////////

#define VAX_AUDIO_TYPE_NORMAL							0
#define VAX_AUDIO_TYPE_USER								1
#define VAX_AUDIO_TYPE_ADMIN							2

#define VAX_VIDEO_TYPE_NORMAL							0
#define VAX_VIDEO_TYPE_USER								1
#define VAX_VIDEO_TYPE_ADMIN							2

/////////////////////////////////////////////////////////

#define VAX_PUSH_PROVIDER_IOS							0
#define VAX_PUSH_PROVIDER_ANDROID						1


///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

#import "..\Component (COM)\VaxTeleServerCOM.dll" rename_namespace("VaxTeleServer")

using namespace VaxTeleServer;

class CVaxServerCOM : public CCmdTarget
{
	DECLARE_DYNCREATE(CVaxServerCOM)

public:
	CVaxServerCOM();
	~CVaxServerCOM();

public:

	DWORD m_dwCookie;
	
	_IVaxServerSIPEvents* m_pVaxEvents;
	IVaxServerSIP* m_pVaxSIP;

	//------------------------------------------------------------------------------------------------------------------
	//-------------------------------			Functions Added
	//------------------------------------------------------------------------------------------------------------------
	
	BOOL LoadObjectCOM();
	void UnLoadObjectCOM();
	
private:
		
	BOOL IsLoadedObjectCOM();

public:

	CString GetVersionFile();
	CString GetVersionSDK();

	LONG GetVaxErrorCode(); 
	void SetLicenseKey(LPCTSTR sLicenseKey);
		
	BOOL Initialize(LPCTSTR sDomainRealm);
	void UnInitialize();
	
	BOOL CryptoMediaNONE(BOOL bForced);
	BOOL CryptoMediaSDP(BOOL bForced);

	BOOL SetListenPortRangeRTP(LONG nListenStartPort, LONG nListenEndPort);
	BOOL SetNetworkMediaRTP(LPCTSTR sListenIP, LONG nListenStartPort);
	BOOL AutoForwardStatusResponseSIP(LONG nSessionId, BOOL bDisable);

	BOOL OpenNetworkUDP(LPCTSTR sListenIP, LONG nListenPort);
	BOOL OpenNetworkTCP(LPCTSTR sListenIP, LONG nListenPort);
	BOOL OpenNetworkTLS(LPCTSTR sListenIP, LONG nListenPort, LPCTSTR sCertPEM);

	void CloseNetworkUDP();
	void CloseNetworkTCP();
	void CloseNetworkTLS();

	BOOL AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sAudioCodecList);
	void RemoveUser(LPCTSTR sUserName);
	BOOL RegisterUserExpiry(LONG nExpiry);

	BOOL AcceptRegister(LONG nRegId);
	BOOL RejectRegister(LONG nRegId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	BOOL AuthRegister(LONG nRegId);
	BOOL AttachRegister(LONG nRegId, LPCTSTR sUserName);

	BOOL AddLine(LPCTSTR sLineName, LONG nLineType, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList);
	void RemoveLine(LPCTSTR sLineName);

	BOOL RegisterLine(LPCTSTR sLineName, LONG nExpire);
	BOOL UnRegisterLine(LPCTSTR sLineName);
		
	BOOL AcceptCallSession(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LPCTSTR sToPeerName, LPCTSTR sRoutUID, LONG nTimeout);
	BOOL RejectCallSession(LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	BOOL CloseCallSession(LONG nSessionId);
		
	LONG DialCallSession(LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LPCTSTR sToPeerName, LONG nTimeout);

	/////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////// RingGroup  ////////////////////////////////////////////

	BOOL AddRingGroup(LPCTSTR sGroupName);
	void RemoveRingGroup(LPCTSTR sGroupName);

	BOOL AddRingGroupAgent(LPCTSTR sGroupName, LPCTSTR sUserName);
	void RemoveRingGroupAgent(LPCTSTR sGroupName, LPCTSTR sUserName);

	void SetRingGroupProcessMode(LPCTSTR sGroupName, LONG nProcessMode, LONG nProcessType);
	BOOL SetRingGroupAgentPriority(LPCTSTR sGroupName, LPCTSTR sAgentName, LONG nPriority);

	BOOL AddCallSessionToRingGroup(LPCTSTR sGroupName, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG nSessionId);

	///////////////////////////////////////////////////////////////////////////////////

	BOOL AddCallPickUpGroup(LPCTSTR sGroupName);
	void RemoveCallPickUpGroup(LPCTSTR sGroupName);

	BOOL AddCallPickUpGroupMember(LPCTSTR sGroupName, LPCTSTR sUserName);
	void RemoveCallPickUpGroupMember(LPCTSTR sGroupName, LPCTSTR sUserName);
		
	BOOL PickUpCall(LONG nSessionId, LPCTSTR sUserName);

	///////////////////////////////////////////////////////////////////////////////

	BOOL ParkCallSession(LONG nSessionId, LONG nChannelId, LONG nSlotId);
	BOOL ConnectToParkedCall(LONG nSessionId, LONG nChannelId, LONG nSlotId);

	//////////////////////////////////////////////////////////////////////////////

	BOOL AddQueue(LPCTSTR sQueueName);
	void RemoveQueue(LPCTSTR sQueueName);

	BOOL AddQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);

	void RemoveQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);
	void SetQueueAgentPriority(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nPriority);

	BOOL SetQueueAgentStatus(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nStatusId);
	void SetQueueProcessMode(LPCTSTR sQueueName, LONG nProcessMode, LONG nProcessType);
	
	BOOL AddCallSessionToQueue(LPCTSTR sQueueName, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG nSessionId, LONG nTimeout);
	BOOL RemoveCallSessionFromQueue(LONG nSessionId);

	//////////////////////////////////////////////////////////////////////////////

	BOOL AddStealthListener(LONG nStealthSessionId, LPCTSTR sCapturePeerName);
	
	//////////////////////////////////////////////////////////////////////////////

	LONG AcceptTransferBlind(LONG nTransfererSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sTransferTo, LPCTSTR sToPeerName, LPCTSTR sRouteUID, LONG nTimeout);
	LONG AcceptTransferConsult(LONG nTransfererSessionId, LONG nTransferToSessionId);
	void RejectTransfer(LONG nSessionId);

	//////////////////////////////////////////////////////////////////////////////

	BOOL PlayWaveStartToCallSession(LONG nSessionId, LONG nChannelId, LONG nWaveId, BOOL bLoopPlay, LONG nPlayPosPCM);
	void PlayWaveStopToCallSession(LONG nSessionId, LONG nChannelId, LONG nWaveId);
	
	BOOL PlayWaveSetVolumeToCallSession(LONG nSessionId, LONG nChannelId, LONG nWaveId, LONG nVolume);
	BOOL PlayWaveSetModeTypeToCallSession(LONG nSessionId, LONG nChannelId, LONG nPlayModeType);

	//////////////////////////////////////////////////////////////////////////////

	BOOL RecordWaveStartToCallSession(LONG nSessionId, LONG nChannelId, LPCTSTR sFileName);
	void RecordWaveStopToCallSession(LONG nSessionId,  LONG nChannelId);
	BOOL RecordWavePauseToCallSession(LONG nSessionId,  LONG nChannelId, BOOL bEnable);

	LONG LoadWaveFile(LPCTSTR sFileName);
	LONG LoadWavePCM(char* pDataPCM, LONG nSizePCM);

	void UnLoadWaveID(LONG nWaveId);

	BOOL LoadMusicHold(LPCTSTR sFileName);
	void UnLoadMusicHold();

	BOOL AcceptOnHoldRequest(LONG nSessionId);
	BOOL AcceptOffHoldRequest(LONG nSessionId);

	BOOL AcceptChatMessage(LONG nChatMsgId, LPCTSTR sToPeerName);
	void RejectChatMessage(LONG nChatMsgId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	LONG SendChatMessageText(LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LPCTSTR sToPeerName);

	BOOL AcceptChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sToPeerName);
	void RejectChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo);

	BOOL OpenConferenceRoom(LPCTSTR sRoomName);
	void CloseConferenceRoom(LPCTSTR sRoomName);

	BOOL AddCallSessionToConferenceRoom(LPCTSTR sRoomName, LONG nSessionId);
	void RemoveCallSessionFromConferenceRoom(LONG nSessionId);

	BOOL PlayWaveStartToConferenceRoom(LPCTSTR sRoomName, LONG nWaveId, BOOL bLoopPlay, LONG nPlayPosPCM);
	BOOL PlayWaveStopToConferenceRoom(LPCTSTR sRoomName, LONG nWaveId);
	BOOL PlayWaveSetVolumeToConferenceRoom(LPCTSTR sRoomName, LONG nWaveId, LONG nVolume);

	BOOL RecordWaveStartToConferenceRoom(LPCTSTR sRoomName, LPCTSTR sFileName);
	BOOL RecordWaveStopToConferenceRoom(LPCTSTR sRoomName);
	BOOL RecordWavePauseToConferenceRoom(LPCTSTR sRoomName, BOOL bEnable);
		
	BOOL AudioSessionLost(BOOL bEnable, LONG nTimeout);  // Seconds.
	LONG SendInfoVM(LPCTSTR sUserLogin, LONG nNewMsgCount, LONG nOldMsgCount, BOOL bMsgWaiting);
	
	BOOL StartVaxTeleTick(LONG nTickId, LONG nElapse); // milli seconds.
	BOOL StopVaxTeleTick(LONG nTickId);

	BOOL SetUserAgentName(LPCTSTR sName);
	CString GetUserAgentName();
	
	BOOL SetSessionNameSDP(LPCTSTR sName);
	CString GetSessionNameSDP();

	BOOL SendDigitDTMF(LONG nSessionId, LONG nChannelId, LPCTSTR sDigitDTMF, LONG nTypeDTMF);
	BOOL DetectDigitDTMF(LONG nSessionId, LONG nChannelId, LONG nTypeDTMF, BOOL bEnable, LONG nMilliSecTimeout); //Milli Seconds.
		 
	BOOL DialToneToCallSession(BOOL bEnable, LONG nSessionId, LONG nWaveId);
	BOOL DiagnosticLogSIP(BOOL bInbound, BOOL bOutbound);

	LONG SplitCallSession(LONG nSessionId, LONG nChannelId);
	BOOL MoveCall(LONG nSrcSessionId, LONG nSrcChannelId, LONG nDscSessionId);
	
	BOOL CallSessionSendStatusResponse(LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContactURI);
	BOOL CallSessionDetectAMD(LONG nSessionId, LONG nChannelId, BOOL bEnable, LONG nAnalysisTime, LONG nSilenceTime, LONG nSilenceCount);

	BOOL AddCustomHeader(LONG nReqId, LPCTSTR sName, LPCTSTR sValue);
	BOOL RemoveCustomHeader(LONG nReqId, LPCTSTR sName);
	BOOL RemoveCustomHeaderAll(LONG nReqId);

	LONG GetCallSessionTxCodec(LONG nSessionId, LONG nChannelId);
	LONG GetCallSessionRxCodec(LONG nSessionId, LONG nChannelId);

	BOOL BusyLampSubscribeAccept(LONG nSubscrbId, BOOL bAuthenticate, LONG nExpires);
	BOOL BusyLampSubscribeReject(LONG nSubscrbId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	BOOL BusyLampSendStatus(LPCTSTR sFromUserName, LPCTSTR sToUserName, LONG nStateId);

	BOOL AdjustCallSessionVoiceType(LONG nSessionId, LONG nChannelId, LONG nVoiceTypeId);
	BOOL AdjustCallSessionVideoType(LONG nSessionId, LONG nChannelId, LONG nVideoTypeId);

public:

	LONG GetCallCount();
	
public:

	CString GetCallSessionHeaderCallId(LONG nSessionId, LONG nChannelId);
	BOOL CallSessionMuteVoice(LONG nSessionId, LONG nChannelId, BOOL bListen, BOOL bSpeak);
	BOOL VideoCOMM(BOOL bEnable);

	BOOL SetExtDataREC(LONG nSessionId, LONG nChannelId, LPCTSTR sExtData);
	BOOL ConnectToServerREC(LONG nSessionId, LONG nChannelId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LPCTSTR sToPeerName, LONG nTimeout);
	BOOL MuteCallServerREC(LONG nSessionId, LONG nChannelId, LONG nMuteType);

	BOOL AddNetworkRouteSIP(LPCTSTR sAssignedIP, LPCTSTR sRouterIP);
	BOOL AddNetworkRouteRTP(LPCTSTR sAssignedIP, LPCTSTR sRouterIP);
		
	BOOL RefreshCallSession(LONG nSessionId, LONG nChannelId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sAudioCodecList, LONG nAudioFlowType, LONG nVideoFlowType, LONG nTimeout);
	LONG SendNotifyMsgSIP(LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sToPeerName);
	
	///////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////

	BOOL AddUserRouteUID(LPCTSTR sUserName, LPCTSTR sRouteUID);
	BOOL AddLineRouteUID(LPCTSTR sLineName, LPCTSTR sRouteUID, LPCTSTR sDialOutPrefix);

	BOOL AddRingGroupRouteUID(LPCTSTR sGroupName, LPCTSTR sRouteUID);
	BOOL AddCallPickUpGroupRouteUID(LPCTSTR sRouteUID);
	
	BOOL AddQueueRouteUID(LPCTSTR sQueueName, LPCTSTR sRouteUID);
	BOOL AddCallParkRouteUID(LPCTSTR sRouteUID);
	
	BOOL AddConferenceRoomRouteUID(LPCTSTR sRoomName, LPCTSTR sRouteUID);
	BOOL AddStealthListenRouteUID(LPCTSTR sRouteUID);

	void RemoveRouteUID(LPCTSTR sRouteUID);

	///////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////

	BOOL SendAudioPCM(LONG nSessionId, LONG nChannelId, char* pDataPCM, LONG nSizePCM);
	BOOL AccessAudioPCM(LONG nSessionId, LONG nChannelId, LPCTSTR sPipeName, LONG nAccessType);
		
	///////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////
		
	BOOLEAN ActivatePushSIP(BOOLEAN bActivate, int nWaitSeconds);
	BOOLEAN SetUserPushSIP(LPCTSTR sUserName, int nProviderPN, LPCTSTR sProjectPN, LPCTSTR sDevicePN);

public:

	afx_msg virtual void OnFinalRelease();


///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

protected:

	virtual void OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	virtual void OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	virtual void OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	virtual void OnUnRegisterUser(LPCTSTR sUserLogin);

	virtual void OnCallSessionConnecting(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnCallSessionFailed(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContact);
	virtual void OnCallSessionConnected(LONG nSessionId);

	virtual void OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sRouteUID, LONG nRouteType, LPCTSTR sRouteName, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort);

	virtual void OnCallSessionCreated(LONG nSessionId, LONG nReasonCode);
	virtual void OnCallSessionClosed(LONG nSessionId, LONG nChannelId, LONG nReasonCode);

	virtual void OnCallSessionLost(LONG nSessionId, LONG nChannelId);
	virtual void OnCallSessionHangup(LONG nSessionId, LONG nChannelId);
	virtual void OnCallSessionTimeout(LONG nSessionId, LONG nChannelId);
	virtual void OnCallSessionCancelled(LONG nSessionId);

	virtual void OnCallSessionOnHold(LONG nSessionId, LONG nChannelId);
	virtual void OnCallSessionOffHold(LONG nSessionId, LONG nChannelId);

	virtual void OnCallSessionTransferBlind(LONG nTransfererSessionId, LONG nTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo, LPCTSTR sRouteUID, LONG nRouteType, LPCTSTR sRouteName);
	virtual void OnCallSessionTransferConsult(LONG nTransfererSessionId, LONG nTransfereeSessionId, LONG nTransferToSessionId, LONG nTransfererChannelId, LONG nTransfereeChannelId, LONG nTransferToChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);

	virtual void OnCallSessionTransfering(LONG nSessionId, LONG nTransferType, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnCallSessionTransferFailed(LONG nSessionId, LONG nTransferType, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnCallSessionTransferTimeout(LONG nSessionId, LONG nTransferType, LONG nChannelId);
	virtual void OnCallSessionTransfered(LONG nSessionId, LONG nTransferType);

	virtual void OnLineRegisterTrying(LPCTSTR sLineName);
	virtual void OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnLineRegisterSuccess(LPCTSTR sLineName);

	virtual void OnLineUnRegisterTrying(LPCTSTR sLineName);
	virtual void OnLineUnRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnLineUnRegisterSuccess(LPCTSTR sLineName);

	virtual void OnChatMessageText(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	virtual void OnChatMessageTyping(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, BOOL bIsTypingStart, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);

	virtual void OnChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	virtual void OnChatStatusSendSubscribeSuccess(LONG nSubscrbId);
	virtual void OnChatStatusSendSubscribeFailed(LONG nSubscrbId, LONG nStatusCode, LPCTSTR sReasonPhrase);

	virtual void OnChatMessageSuccess(LONG nChatMsgId);
	virtual void OnChatMessageFailed(LONG nChatMsgId, LONG nStatusId, LPCTSTR sReasonPhrase);
	virtual void OnChatMessageTimeout(LONG nChatMsgId);

	virtual void OnOutgoingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sToIP, LONG nToPort);
	virtual void OnIncomingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sFromIP, LONG nFromPort);

	virtual void OnDetectedDigitDTMF(LONG nSessionId, LONG nChannelId, LPCTSTR sDigitDTMF, LONG nTypeDTMF);
	virtual void OnVaxTeleTick(LONG nTickId);

	virtual void OnSendTimeoutVM(LONG nMsgIdVM);
	virtual void OnSendSuccessVM(LONG nMsgIdVM);

	virtual void OnCallSessionDialToneStarted(LONG nSessionId, LONG nChannelId, LONG nWaveId);
	virtual void OnCallSessionDialToneEnded(LONG nSessionId, LONG nChannelId, LONG nWaveId);

	virtual void OnCallSessionPlayWaveDone(LONG nSessionId, LONG nChannelId, LONG nWaveId);
	virtual void OnConferenceRoomPlayWaveDone(LPCTSTR sRoomName, LONG nWaveId);

	virtual void OnCallSessionDetectedAMD(LONG nSessionId, LONG nChannelId, BOOL bIsHuman);

	virtual void OnCallSessionRecordedPCM(LONG nSessionId, LONG nChannelId, char* pDataPCM, LONG nSizePCM, LONG nTypePCM);
	virtual void OnConferenceRoomRecordedPCM(LPCTSTR sRoomName, char* pDataPCM, LONG nSizePCM, LONG nTypePCM);

	virtual void OnBusyLampSubscribe(LONG nSubscrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort);
	virtual void OnBusyLampUnSubscribe(LONG nSubscrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort);
	virtual void OnBusyLampSubscribeSuccess(LONG nSubscrbId, LPCTSTR sUserName);
	virtual void OnBusyLampSubscribeFailed(LONG nSubscrbId, LPCTSTR sUserName);
	virtual void OnBusyLampSendStatus(LPCTSTR sFromUserName, LPCTSTR sToUserName, LONG nStateId);

	virtual void OnCallSessionErrorLog(LONG nSessionId, LONG nChannelId, LONG nErrorCode, LPCTSTR sErrorMsg);
	virtual void OnVaxErrorLog(LPCTSTR sFuncName, LONG nErrorCode, LPCTSTR sErrorMsg);

	virtual void OnVaxLicenseChannel(LONG nTotalChannels, LONG nUsedChannels);

	virtual void OnAddCallSessionToQueueSuccess(LPCTSTR sQueueName, LONG nSessionId);
	virtual void OnAddCallSessionToQueueFailed(LPCTSTR sQueueName, LONG nSessionId);

	virtual void OnQueuePlayWaveStarted(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);
	virtual void OnQueuePlayWaveEnded(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);

	virtual void OnQueueAgentConnectStarted(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId);
	virtual void OnQueueAgentConnectTrying(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnQueueAgentConnectFailed(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnQueueAgentConnectTimeout(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId);
	virtual void OnQueueAgentConnectSuccess(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId);

	virtual void OnAddCallSessionToRingGroupSuccess(LPCTSTR sGroupName, LONG nSessionId);
	virtual void OnAddCallSessionToRingGroupFailed(LPCTSTR sGroupName, LONG nSessionId);

	virtual void OnServerConnectingREC(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnServerConnectedREC(LONG nSessionId, LONG nChannelId);
	virtual void OnServerFailedREC(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);
	virtual void OnServerTimeoutREC(LONG nSessionId, LONG nChannelId);
	virtual void OnServerHungupREC(LONG nSessionId, LONG nChannelId);

	virtual void OnSendReqTransferCallTimeout(LONG nSessionId, LONG nChannelId);
	virtual void OnSendReqTransferCallAccepted(LONG nSessionId, LONG nChannelId);
	virtual void OnSendReqTransferCallFailed(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase);

	virtual void OnQualityReportPUBLISH(LPCTSTR sMsgSIP, LPCTSTR sMsgSDP, LPCTSTR sFromIP, LONG nFromPort);

	virtual void OnSendNotifyMsgSuccess(LONG nMsgId);
	virtual void OnSendNotifyMsgFailed(LONG nMsgId, LONG nStatusCode, LPCTSTR sReasonPhrase);

	virtual void OnCallParkPlayWaveStarted(LONG nSessionId, LONG nChannelId);
	virtual void OnCallParkPlayWaveEnded(LONG nSessionId, LONG nChannelId);

	virtual void OnCallSessionAccessAudioPCM(LONG nSessionId, LONG nChannelId, LONG nAccessType, char* pDataPCM, LONG nSizePCM, LONG nTypePCM);
	virtual void OnStealthListenerAttached(LONG nAttachType, LONG nStealthSessionId, LONG nAttachSessionId, LONG nAttachChannelId);

	virtual void OnCallSessionPushSIP(LONG nSessionId, LONG nChannelId, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG nProviderPN, LPCTSTR sProjectPN, LPCTSTR sDevicePN);
	virtual void OnRegisterUserPushSIP(LPCTSTR sUserName, LONG nProviderPN, LPCTSTR sProjectPN, LPCTSTR sDevicePN);

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CVaxServerCOM)
						
	//}}AFX_DISPATCH

	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

};

