// AddLineDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "VaxTeleServerAppDlg.h"
#include "AddLineDlg.h"
#include "Codec.h"

#include "VaxLine.h"

#include "StoreLine.h"
#include "StoreUser.h"
#include "StoreRoom.h"
#include "StoreQueue.h"
#include "StoreRingGroup.h"

#include "VaxServerSIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddLineDlg dialog


CAddLineDlg::CAddLineDlg() : CPropertyPage(CAddLineDlg::IDD)
{
	//{{AFX_DATA_INIT(CAddLineDlg)

	m_sConnectToRoom = _T("");
	m_sConnectToLogin = _T("");
	m_sConnectToQueue = _T("");
	m_sConnectToRingGroup = _T("");
	
	m_sLineName = _T("");
	
	m_sLineAuthLogin = _T("");
	m_sLineAuthPwd = _T("");
	
	m_sLineServerAddr = _T("");
	m_nLineServerPort = SIP_DEFAULT_PORT;

	m_bLineRegister = FALSE;

	m_nRadioCtrlLineType = VAX_LINE_TYPE_UDP;
	m_nRadioCtrlInboundCall = 0;

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button
}


void CAddLineDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddLineDlg)
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_USER, m_ctrlComboConnectToLogin);
	DDX_Control(pDX, IDC_COMBO_LINE, m_ctrlComboLine);
	DDX_Control(pDX, IDC_LIST_LINE_DISABLE_CODEC, m_ctrlDisableCodecList);
	DDX_Control(pDX, IDC_LIST_LINE_ENABLE_CODEC, m_ctrlEnableCodecList);

	DDX_Text(pDX, IDC_EDIT_LINE_AUTH_USER, m_sLineAuthLogin);
	DDX_Text(pDX, IDC_EDIT_LINE_PASSWORD, m_sLineAuthPwd);
	DDX_Text(pDX, IDC_EDIT_LINE_SERVER_ADDR, m_sLineServerAddr);
	DDX_Text(pDX, IDC_EDIT_LINE_SERVER_PORT, m_nLineServerPort);
	DDX_Check(pDX, IDC_CHECK_REG_START_UP, m_bLineRegister);
		
	DDX_CBString(pDX, IDC_COMBO_LINE, m_sLineName);

	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_ROOM, m_ctrlComboConnectToRoom);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_ROOM, m_sConnectToRoom);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_USER, m_sConnectToLogin);
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_TO_QUEUE, m_objComboQueueList);
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_TO_GROUP, m_objComboRingGroupList);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_TO_QUEUE, m_sConnectToQueue);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_TO_GROUP, m_sConnectToRingGroup);

	DDX_Radio(pDX, IDC_RADIO_LINE_REJECT_CALL, m_nRadioCtrlInboundCall);
	DDX_Radio(pDX, IDC_RADIO_LINE_TYPE_UDP, m_nRadioCtrlLineType);
}


BEGIN_MESSAGE_MAP(CAddLineDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAddLineDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_LINE, OnSelchangeComboLine)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_LINE_DLG, OnButtonClearLineDlg)
	ON_BN_CLICKED(IDC_BUTTON_LINE_DISABLE_CODEC, OnButtonLineDisableCodec)
	ON_BN_CLICKED(IDC_BUTTON_LINE_ENABLE_CODEC, OnButtonLineEnableCodec)
	ON_BN_CLICKED(IDC_BUTTON_LINE_ADD, OnButtonLineAdd)
	ON_BN_CLICKED(IDC_BUTTON_LINE_REMOVE, OnButtonLineRemove)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddLineDlg message handlers

BOOL CAddLineDlg::OnSetActive()
{
	AddLines();
	
	AddUsers();
	AddRooms();
	
	AddQueues();
	AddRingGroups();

	ShowLineDetails();

	return CPropertyPage::OnSetActive();
}

BOOL CAddLineDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_ctrlComboLine.SetWindowPos(NULL, 0 , 0, 220, 150, SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboConnectToLogin.SetWindowPos(NULL, 0, 0, 120, 150, SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboConnectToRoom.SetWindowPos(NULL, 0, 0, 120, 150, SWP_NOMOVE|SWP_NOZORDER);

	UpdateData(FALSE);
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::OnButtonLineAdd() 
{
	UpdateData();
	
	if(!AddLineChecks())
		return;
	
	if(m_ctrlComboLine.FindStringExact(0, m_sLineName) != -1)
	{
		if(MessageBox("Line already exists, do you want to continue?", "VaxVoIP", MB_ICONEXCLAMATION|MB_YESNO) == IDNO)
			return;
	}
			
	//////////////////////////////////////////////////////////////////////////

	CString sToPeerName, sRoomName, sQueueName, sRingGroupName;
	BOOL bRejected = FALSE;

	GetIncomingCallInfo(sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
	
	//////////////////////////////////////////////////////////////////////////
	
	CString sAudioCodecList = GetAudioCodecUI();
	LONG nLineType = GetLineTypeUI();

	//////////////////////////////////////////////////////////////////////////

	if(!CVaxLine::AddLine(m_sLineName, nLineType, m_sLineAuthLogin, m_sLineAuthPwd, m_sLineServerAddr, m_nLineServerPort, sAudioCodecList, m_bLineRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName))
	{
		MessageBox("Line could not be added/updated or Please start the server first.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
		
	if(m_ctrlComboLine.FindStringExact(0, m_sLineName) == -1)
		m_ctrlComboLine.AddString(m_sLineName);
			
	MessageBox("Line added/updated successfully.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::OnButtonLineRemove()
{
	UpdateData();
	
	if(m_sLineName.IsEmpty())
	{
		MessageBox("Please enter a Line Name.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	LONG nIndex = m_ctrlComboLine.FindStringExact(0, m_sLineName);
	if(nIndex == -1) return;

	CVaxLine::RemoveLine(m_sLineName);
	m_ctrlComboLine.DeleteString(nIndex);
	
	ClearDlgUI();
	
	if(m_ctrlComboLine.GetCount() > 0)
		m_ctrlComboLine.SetCurSel(0);
		
	ShowLineDetails();
	
	MessageBox("Line removed successfully!", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::OnSelchangeComboLine() 
{
	ShowLineDetails();
}

void CAddLineDlg::OnButtonClearLineDlg() 
{
	ClearDlgUI();
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::ShowLineDetails()
{
	LONG nCurIndex = m_ctrlComboLine.GetCurSel();
	if(nCurIndex == -1) return;

	CString sLineName;
	m_ctrlComboLine.GetLBText(nCurIndex, sLineName);
	
	CString sAuthUser, sAuthPwd, sServerAddr, sAudioCodecList;
	CString	sToPeerName, sRoomName, sQueueName, sRingGroupName;

	LONG nLineType = VAX_LINE_TYPE_UDP, nServerPort = SIP_DEFAULT_PORT;
	BOOL bRegister = FALSE, bRejected = TRUE;

	CStoreLine::GetLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName,  sQueueName, sRingGroupName);
	UpdateDlgUI(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::GetIncomingCallInfo(CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName)
{
	if(m_nRadioCtrlInboundCall == 0)
	{
		bRejected = TRUE;
	}
	else if(m_nRadioCtrlInboundCall == 1)
	{
		sToPeerName = m_sConnectToLogin;
	}
	
	else if(m_nRadioCtrlInboundCall == 2)
	{
		sRoomName = m_sConnectToRoom;
	}

	else if(m_nRadioCtrlInboundCall == 3)
	{
		sQueueName = m_sConnectToQueue;
	}

	else if(m_nRadioCtrlInboundCall == 4)
	{
		sRingGroupName = m_sConnectToRingGroup;
	}
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::UpdateDlgUI(LPCTSTR sLineName, LONG nLineType, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList, BOOL bRegister, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName)
{
	m_sLineName = sLineName;
	
	m_sLineAuthLogin = sAuthLogin;
	m_sLineAuthPwd = sAuthPwd;
	
	m_sLineServerAddr = sServerAddr;
	m_nLineServerPort = nServerPort;
		
	m_bLineRegister = bRegister;

	UpdateLineTypeUI(nLineType);
	UpdateAudioCodecUI(sAudioCodecList);

	UpdateIncomingCallUI(sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
	UpdateData(FALSE);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::UpdateAudioCodecUI(LPCTSTR sAudioCodecList)
{
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(LONG nCount = 0; nCount < VAX_CODEC_TOTAL_COUNT; nCount++)	
		m_ctrlDisableCodecList.AddString(CCodec::GetCodecName(nCount));
	
	CStringList objCodecNameList;
	CCodec::GetCodecName(sAudioCodecList, objCodecNameList);

	while(!objCodecNameList.IsEmpty())
	{
		CString sCodecName = objCodecNameList.RemoveHead();
		m_ctrlEnableCodecList.AddString(sCodecName);
		
		LONG nIndex = m_ctrlDisableCodecList.FindStringExact(0, sCodecName);
		if(nIndex == -1) continue;
		
		m_ctrlDisableCodecList.DeleteString(nIndex);
	}
}

CString CAddLineDlg::GetAudioCodecUI()
{
	CString sCodec;
	
	for(LONG nCount = 0; nCount < m_ctrlEnableCodecList.GetCount(); nCount++)
	{
		CString sCodecText;
		m_ctrlEnableCodecList.GetText(nCount, sCodecText);

		sCodec += CCodec::GetCodecNo(sCodecText);
	}

	return sCodec;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::UpdateLineTypeUI(LONG nLineType)
{
	if (nLineType == VAX_LINE_TYPE_UDP)
		m_nRadioCtrlLineType = 0;

	else if (nLineType == VAX_LINE_TYPE_TCP)
		m_nRadioCtrlLineType = 1;

	else if (nLineType == VAX_LINE_TYPE_TLS)
		m_nRadioCtrlLineType = 2;
	else
		m_nRadioCtrlLineType = VAX_LINE_TYPE_UDP;

	UpdateData(FALSE);
}

LONG CAddLineDlg::GetLineTypeUI()
{
	UpdateData();

	if (m_nRadioCtrlLineType == 0)
	{
		return VAX_LINE_TYPE_UDP;
	}

	if (m_nRadioCtrlLineType == 1)
	{
		return VAX_LINE_TYPE_TCP;
	}

	if (m_nRadioCtrlLineType == 2)
	{
		return VAX_LINE_TYPE_TLS;
	}

	return VAX_LINE_TYPE_UDP;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::UpdateIncomingCallUI(LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName)
{
	if(bRejected)
	{
		m_nRadioCtrlInboundCall = 0;
	}

	else if(!CString(sToPeerName).IsEmpty())
	{
		m_nRadioCtrlInboundCall = 1;
		m_ctrlComboConnectToLogin.SelectString(0, sToPeerName);
	}

	else if(!CString(sRoomName).IsEmpty())
	{
		m_nRadioCtrlInboundCall = 2;
		m_ctrlComboConnectToRoom.SelectString(0, sRoomName);
	}

	else if(!CString(sQueueName).IsEmpty())
	{
		m_nRadioCtrlInboundCall = 3;
		m_sConnectToQueue = sQueueName;
		m_objComboQueueList.SelectString(0, sQueueName);
	}
	
	else if(!CString(sRingGroupName).IsEmpty())
	{
		m_nRadioCtrlInboundCall = 4;
		m_sConnectToRingGroup = sRingGroupName;
		m_objComboRingGroupList.SelectString(0, sRingGroupName);
	}
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::ClearDlgUI()
{
	m_sLineName	= "";

	m_sLineAuthLogin = "";
	m_sLineAuthPwd = "";
	
	m_bLineRegister	= FALSE;

	m_sLineServerAddr = "";
	m_nLineServerPort = SIP_DEFAULT_PORT;
	
	if(m_ctrlComboConnectToLogin.GetCount() > 0)
		m_ctrlComboConnectToLogin.SetCurSel(0);

	if(m_ctrlComboConnectToRoom.GetCount() > 0)
		m_ctrlComboConnectToRoom.SetCurSel(0);

	if(m_objComboQueueList.GetCount() > 0)
		m_objComboQueueList.SetCurSel(0);

	if(m_objComboRingGroupList.GetCount() > 0)
		m_objComboRingGroupList.SetCurSel(0);
		
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_G711U);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_G711A);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_ILBC);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_GSM610);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_G729);
	
	m_nRadioCtrlInboundCall = 0;
	m_nRadioCtrlLineType = VAX_LINE_TYPE_UDP;
	
	UpdateData(FALSE);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::AddLines()
{
	m_ctrlComboLine.ResetContent();

	CStringList objLineList;
	CStoreLine::GetLineNameAll(objLineList);
		
	while(!objLineList.IsEmpty())
		m_ctrlComboLine.AddString(objLineList.RemoveHead());

	if(m_ctrlComboLine.GetCount() > 0)
		m_ctrlComboLine.SetCurSel(0);
}

void CAddLineDlg::AddUsers()
{
	m_ctrlComboConnectToLogin.ResetContent();

	CStringList objListUsers;
	CStoreUser::GetUserAll(objListUsers);

	while(!objListUsers.IsEmpty())
		m_ctrlComboConnectToLogin.AddString(objListUsers.RemoveHead());
			
	if(m_ctrlComboConnectToLogin.GetCount() > 0)
		m_ctrlComboConnectToLogin.SetCurSel(0);
}

void CAddLineDlg::AddRooms()
{
	m_ctrlComboConnectToRoom.ResetContent();

	CStringList objRoomList;
	CStoreRoom::GetRoomNameAll(objRoomList);

	if(objRoomList.GetCount() <= 0) return;

	while(!objRoomList.IsEmpty())
		m_ctrlComboConnectToRoom.AddString(objRoomList.RemoveHead());
		
	if(m_ctrlComboConnectToRoom.GetCount() > 0)
		m_ctrlComboConnectToRoom.SetCurSel(0);
}

void CAddLineDlg::AddQueues()
{
	m_objComboQueueList.ResetContent();

	CStringList sListQueueName;
	CStoreQueue::GetQueueNameAll(sListQueueName);
		
	while(!sListQueueName.IsEmpty())
		m_objComboQueueList.AddString(sListQueueName.RemoveHead());

	if(m_objComboQueueList.GetCount() > 0)
		m_objComboQueueList.SetCurSel(0);
}

void CAddLineDlg::AddRingGroups()
{
	m_objComboRingGroupList.ResetContent();
	
	CStringList sListRingGroupName;
	CStoreRingGroup::GetGroupNameAll(sListRingGroupName);
		
	while(!sListRingGroupName.IsEmpty())
		m_objComboRingGroupList.AddString(sListRingGroupName.RemoveHead());

	if(m_objComboRingGroupList.GetCount() > 0)
		m_objComboRingGroupList.SetCurSel(0);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

BOOL CAddLineDlg::AddLineChecks()
{
	UpdateData();
	
	if(m_sLineName.IsEmpty())
	{
		MessageBox("Please enter a Line Name.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
		
	if(m_ctrlEnableCodecList.GetCount() == 0)
	{
		MessageBox("Please select a codec.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLineDlg::OnButtonLineDisableCodec() 
{
	LONG nCurSel = m_ctrlEnableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	m_ctrlEnableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlEnableCodecList.DeleteString(nCurSel);
	
	m_ctrlDisableCodecList.AddString(sCurSelText);
}

void CAddLineDlg::OnButtonLineEnableCodec() 
{
	LONG nCurSel = m_ctrlDisableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	
	m_ctrlDisableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlDisableCodecList.DeleteString(nCurSel);
	
	m_ctrlEnableCodecList.AddString(sCurSelText);
}


void CAddLineDlg::OnDestroy() 
{
	CPropertyPage::OnDestroy();
}