#include "afxwin.h"

#pragma once

class CAddLineDlg : public CPropertyPage
{

public:

	CAddLineDlg();
	
private:
	
	void UpdateDlgUI(LPCTSTR sLineName, LONG nLineType, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList, BOOL bRegister, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	
	void UpdateLineTypeUI(LONG nLineType);
	LONG GetLineTypeUI();

	void UpdateAudioCodecUI(LPCTSTR sAudioCodecList);
	CString GetAudioCodecUI();

	void UpdateIncomingCallUI(LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void GetIncomingCallInfo(CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);
	
private:

	void ClearDlgUI();
	BOOL AddLineChecks();

private:
		
	void AddLines();
	void AddUsers();
	void AddRooms();
	void AddQueues();
	void AddRingGroups();

	void ShowLineDetails();
	
private:

// Dialog Data
	//{{AFX_DATA(CAddLineDlg)
	enum { IDD = IDD_DIALOG_ADD_LINE };

private:

	CComboBox	m_ctrlComboConnectToLogin;
	CComboBox	m_ctrlComboLine;
	
	CComboBox	m_ctrlComboConnectToRoom;
		
	CListBox	m_ctrlDisableCodecList;
	CListBox	m_ctrlEnableCodecList;
	
	CString	m_sLineName;
	CString	m_sLineAuthLogin;
	CString	m_sLineAuthPwd;

	CString	m_sLineServerAddr;
	int m_nLineServerPort;

	BOOL m_bLineRegister;
	
	CComboBox m_objComboQueueList;
	CComboBox m_objComboRingGroupList;
	
	CString m_sConnectToRoom;
	CString m_sConnectToLogin;
	
	CString m_sConnectToQueue;
	CString m_sConnectToRingGroup;

	int	m_nRadioCtrlInboundCall;
	int m_nRadioCtrlLineType;
	
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAddLineDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation

protected:

	// Generated message map functions
	
	virtual BOOL OnInitDialog();


	afx_msg void OnSelchangeComboLine();
	afx_msg void OnButtonClearLineDlg();

	afx_msg void OnButtonLineDisableCodec();
	afx_msg void OnButtonLineEnableCodec();

	afx_msg void OnButtonLineAdd();
	afx_msg void OnButtonLineRemove();
	afx_msg void OnDestroy();

	DECLARE_MESSAGE_MAP()

public:
	
	virtual BOOL OnSetActive();
};
