// AddLoginDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "VaxTeleServerAppDlg.h"
#include "AddLoginDlg.h"
#include "Codec.h"
#include "VaxServerSIP.h"

#include "VaxUser.h"
#include "StoreLine.h"
#include "StoreUser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CAddLoginDlg dialog


CAddLoginDlg::CAddLoginDlg() : CPropertyPage(CAddLoginDlg::IDD)
{
	//{{AFX_DATA_INIT(CAddLoginDlg)
	
	m_sPasswordSIP = _T("");
	m_bAccountBlocked = FALSE;
	m_sLoginSIP = _T("");

	m_sDialPrefix = _T("");
	m_sUserPrefix = _T("");
		
	//}}AFX_DATA_INIT

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button

	m_nRadioCtrlLoginType = VAX_AUDIO_TYPE_NORMAL;
}


void CAddLoginDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddLoginDlg)
	DDX_Control(pDX, IDC_COMBO_LOGIN, m_ctrlComboLogin);
	DDX_Control(pDX, IDC_LIST_ENABLE_CODEC, m_ctrlEnableCodecList);
	DDX_Control(pDX, IDC_LIST_DISABLE_CODEC, m_ctrlDisableCodecList);
	DDX_Text(pDX, IDC_EDIT_PWD_SIP, m_sPasswordSIP);
	DDX_Check(pDX, IDC_CHECK_BLOCK_ACCOUNT, m_bAccountBlocked);
	DDX_CBString(pDX, IDC_COMBO_LOGIN, m_sLoginSIP);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_EDIT_DIAL_PLAN_DIAL_PREFIX, m_sDialPrefix);
	DDX_Text(pDX, IDC_EDIT_DIAL_PLAN_USER_PREFIX, m_sUserPrefix);
	DDX_Control(pDX, IDC_COMBO_LOGIN_ROUTES, m_ctrlComboLoginRoute);
	DDX_Radio(pDX, IDC_RADIO_LOGIN_TYPE_ADMIN, m_nRadioCtrlLoginType);
	DDX_Control(pDX, IDC_EDIT_PWD_SIP, m_ctrlEditPassword);
}


BEGIN_MESSAGE_MAP(CAddLoginDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAddLoginDlg)
	ON_BN_CLICKED(IDC_BUTTON_LOGIN_ADD, OnButtonLoginAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_LOGIN, OnButtonRemoveLogin)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_CODEC, OnButtonEnableCodec)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE_CODEC, OnButtonDisableCodec)
	ON_CBN_SELCHANGE(IDC_COMBO_LOGIN, OnSelchangeComboLogin)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_LOGIN_HELP, OnButtonLoginHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddLoginDlg message handlers

BOOL CAddLoginDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_ctrlComboLogin.SetWindowPos(NULL, 0, 0, 220, 150, SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlEditPassword.SetWindowPos(NULL, 0, 0, 220, 21, SWP_NOMOVE|SWP_NOZORDER);
		
	return TRUE;  // return TRUE unless you set the focus to a control
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::OnButtonLoginAdd() 
{
	UpdateData();

	if(!AddLoginChecks())
		return;
		
	if(m_ctrlComboLogin.FindStringExact(0, m_sLoginSIP) != -1)
	{
		if(MessageBox("Login already exists, do you want to continue?", "VaxVoIP", MB_ICONEXCLAMATION|MB_YESNO) == IDNO)
			return;
	}

	////////////////////////////////////////////////////////////////////////////////////////////

	CString sUserPrefix, sDialPrefix;
	CString sToPeerName;

	GetRouteUI(sUserPrefix, sDialPrefix, sToPeerName);

	////////////////////////////////////////////////////////////////////////////////////////////
		
	CString sAudioCodecList = GetAudioCodecUI();
	LONG nVoiceTypeId = GetUserTypeUI();

	//////////////////////////////////////////////////////////////////////////////////////////
		
	if(!CVaxUser::AddUser(m_sLoginSIP, m_sPasswordSIP, sAudioCodecList, m_bAccountBlocked, nVoiceTypeId, m_sUserPrefix, m_sDialPrefix, sToPeerName))
	{
		MessageBox("Login could not be created or Please start the server first.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	if(m_ctrlComboLogin.FindStringExact(0, m_sLoginSIP) == -1)
		m_ctrlComboLogin.AddString(m_sLoginSIP);
		
	MessageBox("Login added/updated successfully.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
}

void CAddLoginDlg::OnButtonRemoveLogin() 
{
	UpdateData();
	
	if(m_sLoginSIP.IsEmpty())
	{
		MessageBox("Please enter a login name.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}

	LONG nIndex = m_ctrlComboLogin.FindStringExact(0, m_sLoginSIP);
	if(nIndex == -1) return;

	CVaxUser::RemoveUser(m_sLoginSIP);
	m_ctrlComboLogin.DeleteString(nIndex);	
	
	ClearDlgUI();
	
	if(m_ctrlComboLogin.GetCount() > 0)
		m_ctrlComboLogin.SetCurSel(0);
		
	ShowLoginDetails();
	
	MessageBox("Login removed successfully!", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::OnButtonEnableCodec() 
{
	LONG nCurSel = m_ctrlDisableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	
	m_ctrlDisableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlDisableCodecList.DeleteString(nCurSel);
	
	m_ctrlEnableCodecList.AddString(sCurSelText);
}

void CAddLoginDlg::OnButtonDisableCodec() 
{
	LONG nCurSel = m_ctrlEnableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;

	m_ctrlEnableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlEnableCodecList.DeleteString(nCurSel);
	
	m_ctrlDisableCodecList.AddString(sCurSelText);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::OnSelchangeComboLogin() 
{
	ShowLoginDetails();
}

void CAddLoginDlg::OnButtonClear() 
{
	ClearDlgUI();
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::LoadLoginAll()
{
	m_ctrlComboLogin.ResetContent();

	CStringList objListUsers;
	CStoreUser::GetUserAll(objListUsers);
		
	while(!objListUsers.IsEmpty())
	{
		m_ctrlComboLogin.AddString(objListUsers.RemoveHead());
	}
		
	if(m_ctrlComboLogin.GetCount() > 0)
		m_ctrlComboLogin.SetCurSel(0);
}

void CAddLoginDlg::LoadRouteLineAll()
{
	CStringList objLineList;
	CStoreLine::GetLineNameAll(objLineList);
			
	while(!objLineList.IsEmpty())
	{
		CString sLineName = objLineList.RemoveHead();

		LONG nIndex = m_ctrlComboLoginRoute.AddString(sLineName);
		m_ctrlComboLoginRoute.SetItemData(nIndex, VAX_PEER_TYPE_LINE);
	}

	if(m_ctrlComboLoginRoute.GetCount() > 0)
		m_ctrlComboLoginRoute.SetCurSel(0);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

BOOL CAddLoginDlg::OnSetActive()
{
	m_ctrlComboLoginRoute.ResetContent();
	
	LoadLoginAll();
	LoadRouteLineAll();
	
	ShowLoginDetails();
	return CPropertyPage::OnSetActive();
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::ShowLoginDetails()
{
	LONG nCurIndex = m_ctrlComboLogin.GetCurSel();
	if(nCurIndex == -1) return;

	CString sLogin;
	m_ctrlComboLogin.GetLBText(nCurIndex, sLogin);
				
	CString sPassword, sUserPrefix, sDialPrefix;
	CString sAudioCodecList, sToPeerName;

	BOOL bBlocked = TRUE;
	LONG nVoiceTypeId = VAX_AUDIO_TYPE_NORMAL;
	
	CStoreUser::GetUser(sLogin, sPassword, sAudioCodecList, bBlocked, nVoiceTypeId, sUserPrefix, sDialPrefix, sToPeerName);	
	UpdateDlgUI(sLogin, sPassword, sAudioCodecList, bBlocked, nVoiceTypeId, sUserPrefix, sDialPrefix, sToPeerName);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::UpdateDlgUI(LPCTSTR sLogin, LPCTSTR sPassword, LPCTSTR sAudioCodecList, BOOL bBlocked, LONG nVoiceTypeId, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, LPCTSTR sToPeerName)
{
	m_sLoginSIP = sLogin;
	m_sPasswordSIP = sPassword;
	
	m_bAccountBlocked = bBlocked;

	UpdateUserTypeUI(nVoiceTypeId);
	UpdateAudioCodecUI(sAudioCodecList);
	
	UpdateRouteUI(sUserPrefix, sDialPrefix, sToPeerName);
	UpdateData(FALSE);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::UpdateAudioCodecUI(LPCTSTR sAudioCodecList)
{
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(LONG nCount = 0; nCount < VAX_CODEC_TOTAL_COUNT; nCount++)	
		m_ctrlDisableCodecList.AddString(CCodec::GetCodecName(nCount));
	
	CStringList objCodecNameList;
	CCodec::GetCodecName(sAudioCodecList, objCodecNameList);

	while(!objCodecNameList.IsEmpty())
	{
		CString sCodecName = objCodecNameList.RemoveHead();
		m_ctrlEnableCodecList.AddString(sCodecName);
		
		LONG nIndex = m_ctrlDisableCodecList.FindStringExact(0, sCodecName);
		if(nIndex == -1) continue;
		
		m_ctrlDisableCodecList.DeleteString(nIndex);
	}
}

CString CAddLoginDlg::GetAudioCodecUI()
{
	CString sCodec;
	
	for(LONG nCount = 0; nCount < m_ctrlEnableCodecList.GetCount(); nCount++)
	{
		CString sCodecText;
		m_ctrlEnableCodecList.GetText(nCount, sCodecText);

		sCodec += CCodec::GetCodecNo(sCodecText);
	}

	return sCodec;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::UpdateRouteUI(LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, LPCTSTR sToPeerName)
{
	m_sUserPrefix = sUserPrefix;
	m_sDialPrefix = sDialPrefix;
		
	LONG nIndex = m_ctrlComboLoginRoute.FindStringExact(0, sToPeerName);
	
	if( nIndex != -1)
		m_ctrlComboLoginRoute.SetCurSel(nIndex);
	else
	{
		if(m_ctrlComboLoginRoute.GetCount() > 0)
			m_ctrlComboLoginRoute.SetCurSel(0);
	}

	UpdateData(FALSE);
}

void CAddLoginDlg::GetRouteUI(CString& sUserPrefix, CString& sDialPrefix, CString& sToPeerName)
{
	UpdateData();

	sUserPrefix = "";	sDialPrefix = "";
	sToPeerName = "";

	LONG nSelectedIndex = m_ctrlComboLoginRoute.GetCurSel();
		
	if(nSelectedIndex == -1 || m_sUserPrefix.IsEmpty())
		return;

	sUserPrefix = m_sUserPrefix; 
	sDialPrefix = m_sDialPrefix;

	m_ctrlComboLoginRoute.GetLBText(nSelectedIndex, sToPeerName);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::UpdateUserTypeUI(LONG nUserType)
{
	if (nUserType == VAX_AUDIO_TYPE_ADMIN)
		m_nRadioCtrlLoginType = 0;

	else if (nUserType == VAX_AUDIO_TYPE_USER)
		m_nRadioCtrlLoginType = 1;

	else if (nUserType == VAX_AUDIO_TYPE_NORMAL)
		m_nRadioCtrlLoginType = 2;
	else
		m_nRadioCtrlLoginType = 2;

	UpdateData(FALSE);
}

LONG CAddLoginDlg::GetUserTypeUI()
{
	UpdateData();

	if (m_nRadioCtrlLoginType == 0)
	{
		return VAX_AUDIO_TYPE_ADMIN;
	}

	if (m_nRadioCtrlLoginType == 1)
	{
		return VAX_AUDIO_TYPE_USER;
	}

	if (m_nRadioCtrlLoginType == 2)
	{
		return VAX_AUDIO_TYPE_NORMAL;
	}

	return VAX_AUDIO_TYPE_NORMAL;
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::ClearDlgUI()
{
	m_sLoginSIP    = "";
	m_sPasswordSIP = "";
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_G711U);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_G711A);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_ILBC);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_GSM610);
	m_ctrlEnableCodecList.AddString(AUDIO_CODEC_NAME_G729);
				
	m_bAccountBlocked = FALSE;
	m_nRadioCtrlLoginType = VAX_AUDIO_TYPE_NORMAL;

	m_sUserPrefix = "";
	m_sDialPrefix = "";

	if(m_ctrlComboLoginRoute.GetCount() > 0)
		m_ctrlComboLoginRoute.SetCurSel(0);

	UpdateData(FALSE);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

BOOL CAddLoginDlg::AddLoginChecks()
{
	if(m_sLoginSIP.IsEmpty())
	{
		MessageBox("Please enter login.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	if(!CVaxDefine::IsDigitAll(m_sLoginSIP))
	{
		MessageBox("Login should contain only numerals 0 through 9.\n\nFor example: 12 or 324323 or 800122 or 2109756 etc.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
		
	if(m_sPasswordSIP.IsEmpty())
	{
		MessageBox("Please enter login password.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
		
	if(m_sLoginSIP.GetLength() > 20 || m_sPasswordSIP.GetLength() > 20)
	{
		MessageBox("Login and password size should not be more 20.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	if(m_sLoginSIP.Left(2) == "00")
	{
		MessageBox("Please donot enter 00 as login prefix. 00 prefix is use to prepare dial plan.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	if(m_ctrlEnableCodecList.GetCount() == 0)
	{
		MessageBox("Please select a codec.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CAddLoginDlg::OnButtonLoginHelp() 
{
	
}