// Codec.cpp: implementation of the CCodec class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "VaxServerCOM.h"
#include "Codec.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define AUDIO_CODEC_NO_TEXT_GSM610	"0"
#define AUDIO_CODEC_NO_TEXT_ILBC	"1"
#define AUDIO_CODEC_NO_TEXT_G711A	"2"
#define AUDIO_CODEC_NO_TEXT_G711U	"3"
#define AUDIO_CODEC_NO_TEXT_G729	"4"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCodec::CCodec()
{

}

CCodec::~CCodec()
{

}

CString CCodec::GetCodecNo(CString sCodecName)
{
	if(sCodecName == AUDIO_CODEC_NAME_G711U)
		return AUDIO_CODEC_NO_TEXT_G711U;

	else if(sCodecName == AUDIO_CODEC_NAME_G711A)
		return AUDIO_CODEC_NO_TEXT_G711A;

	else if(sCodecName == AUDIO_CODEC_NAME_ILBC)
		return AUDIO_CODEC_NO_TEXT_ILBC;

	else if(sCodecName == AUDIO_CODEC_NAME_GSM610)
		return AUDIO_CODEC_NO_TEXT_GSM610;

	else if(sCodecName == AUDIO_CODEC_NAME_G729)
		return AUDIO_CODEC_NO_TEXT_G729;

	return "";
}

CString CCodec::GetCodecName(LONG nCodecNo)
{
	CString sCodecName;

	switch (nCodecNo)
    {
		case VAX_CODEC_G711U:
			sCodecName = AUDIO_CODEC_NAME_G711U;
		break;

		case VAX_CODEC_G711A:
			sCodecName = AUDIO_CODEC_NAME_G711A;
		break;

		case VAX_CODEC_ILBC:
			sCodecName = AUDIO_CODEC_NAME_ILBC;
		break;

		case VAX_CODEC_GSM610:
			sCodecName = AUDIO_CODEC_NAME_GSM610;
		break;

		case VAX_CODEC_G729:
			sCodecName = AUDIO_CODEC_NAME_G729;
		break;
	}

	return sCodecName;
}


void CCodec::GetCodecName(CString sAudioCodecList, CStringList& objCodecNameList)
{
	for(LONG nCount = 0; nCount < sAudioCodecList.GetLength(); nCount++)
	{
		char aCodecNo[2] = "\0";
		aCodecNo[0] = sAudioCodecList.GetAt(nCount);

		CString sCodecName = CCodec::GetCodecName(atol(aCodecNo));
		if(sCodecName.IsEmpty()) continue;

		objCodecNameList.AddTail(sCodecName);
	}
}
