// RingGroupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "RingGroupDlg.h"
#include "afxDialogEx.h"
#include "VaxServerSIP.h"

#include "VaxRingGroup.h"
#include "StoreUser.h"
#include "StoreRingGroup.h"

#include"Define.h"

// CRingGroupDlg dialog

IMPLEMENT_DYNAMIC(CRingGroupDlg, CPropertyPage)

CRingGroupDlg::CRingGroupDlg(): CPropertyPage(CRingGroupDlg::IDD)
{
	m_sRingGroupName = _T("");
	m_sAgentName = _T("");
	m_sProcessMode = _T("");
	m_sProcessType = _T("");
}

CRingGroupDlg::~CRingGroupDlg()
{
}

void CRingGroupDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_ADD_RING_GROUP, m_ctrlComboRingGroup);
	DDX_CBString(pDX, IDC_COMBO_ADD_RING_GROUP, m_sRingGroupName);
	DDX_Control(pDX, IDC_COMBO_RING_GROUP_ADD_AGENT, m_ctrlComboAgents);
	DDX_CBString(pDX, IDC_COMBO_RING_GROUP_ADD_AGENT, m_sAgentName);
	DDX_CBString(pDX, IDC_COMBO_RING_GROUP_PROCESS_MODE, m_sProcessMode);
	DDX_Control(pDX, IDC_COMBO_RING_GROUP_PROCESS_MODE, m_ctrlComboProcessMode);
	DDX_Control(pDX, IDC_LIST_AGENT_RING_GROUP, m_ctrlListRingGroupAgent);
	DDX_Control(pDX, IDC_COMBO_RING_GROUP_PROCESS_TYPE, m_ctrlComboProcessType);
	DDX_CBString(pDX, IDC_COMBO_RING_GROUP_PROCESS_TYPE, m_sProcessType);
}


BEGIN_MESSAGE_MAP(CRingGroupDlg, CPropertyPage)

	ON_BN_CLICKED(IDC_BUTTON_ADD_RING_GROUP, &CRingGroupDlg::OnButtonRingGroupAdd)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_RING_GROUP, &CRingGroupDlg::OnButtonRingGroupRemove)
	ON_BN_CLICKED(IDC_BUTTON_RING_GROUP_CLEAR, &CRingGroupDlg::OnButtonClearRingGroupDlg)
	ON_BN_CLICKED(IDC_BUTTON_ADD_RING_GROUP_AGENT, &CRingGroupDlg::OnButtonRingGroupAddAgent)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_RING_GROUP_AGENT, &CRingGroupDlg::OnButtonRingGroupRemoveAgent)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_AGENT, &CRingGroupDlg::OnButtonClearRingGroupAgentDlg)

	ON_CBN_SELCHANGE(IDC_COMBO_ADD_RING_GROUP, &CRingGroupDlg::OnCbnSelchangeComboRingGroup)
END_MESSAGE_MAP()


// CRingGroupDlg message handlers

BOOL CRingGroupDlg::OnSetActive()
{
	AddRingGroups();
	
	AddProcessMode();
	AddProcessType();

	AddUsers();
	ShowRingGroupDetails();

	return CPropertyPage::OnSetActive();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupDlg::OnButtonRingGroupAdd()
{
	UpdateData();

	if(!AddRingGroupChecks())
		return;

	if(m_ctrlComboRingGroup.FindStringExact(0, m_sRingGroupName) != -1)
	{
		LONG nDlgResult = MessageBox("Ring Group already exists, do you want to continue?", "VaxVoIP", MB_ICONEXCLAMATION|MB_YESNO);
		
		if(nDlgResult == IDNO)
			return;
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	CStringList objAgentList;
	GetAgentNameAll(objAgentList);
		
	if(!CVaxRingGroup::AddRingGroup(m_sRingGroupName, GetProcessMode(), GetProcessType(), objAgentList))
	{
		MessageBox("Ring Group could not be added/updated or Please start the server first.", "VaxVoIP", MB_ICONINFORMATION|MB_OK);
		return;
	}
	
	if(m_ctrlComboRingGroup.FindString(0, m_sRingGroupName) == -1)
		m_ctrlComboRingGroup.AddString(m_sRingGroupName);
		
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	MessageBox("Ring Group added/updated successfully.", "VaxVoIP", MB_ICONINFORMATION|MB_OK);
}


void CRingGroupDlg::OnButtonRingGroupRemove()
{
	UpdateData();
	
	LONG nIndex = m_ctrlComboRingGroup.FindStringExact(0, m_sRingGroupName);
	if(nIndex == -1) return;

	CVaxRingGroup::RemoveRingGroup(m_sRingGroupName);
	m_ctrlComboRingGroup.DeleteString(nIndex);

	ClearDlgUI();
	
	if(m_ctrlComboRingGroup.GetCount() > 0)
		m_ctrlComboRingGroup.SetCurSel(0);
		
	ShowRingGroupDetails();
	
	MessageBox("Ring Group removed successfully!", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupDlg::OnButtonRingGroupAddAgent()
{
	UpdateData();

	if(m_sAgentName.IsEmpty())
		return;

	if(m_ctrlListRingGroupAgent.FindString(0, m_sAgentName) > -1)
	{
		MessageBox("Agent already exists.", "VaxVoIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	m_ctrlListRingGroupAgent.AddString(m_sAgentName);
}

void CRingGroupDlg::OnButtonRingGroupRemoveAgent()
{
	LONG nCurIndex = m_ctrlListRingGroupAgent.GetCurSel();
	if(nCurIndex == -1) return;
	
	m_ctrlListRingGroupAgent.DeleteString(nCurIndex);
}

void CRingGroupDlg::OnButtonClearRingGroupAgentDlg()
{
	ClearDlgAgentContent();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupDlg::OnButtonClearRingGroupDlg()
{
	ClearDlgUI();
}

BOOL CRingGroupDlg::AddRingGroupChecks()
{
	if(m_sRingGroupName.IsEmpty())
	{
		MessageBox("PPlease fill all values.", "VaxVoIP", MB_ICONINFORMATION|MB_OK);
		return FALSE;
	}

	if(m_ctrlComboProcessMode.GetCount() == 0)
	{
		MessageBox("Please select a process mode.", "VaxVoIP", MB_ICONINFORMATION|MB_OK);
		return FALSE;
	}

	return TRUE;
}

void CRingGroupDlg::ClearDlgUI()
{
	m_sRingGroupName = "";
	m_sProcessMode = "";
	m_sProcessType = "";
	
	ClearDlgAgentContent();
	
	UpdateData(FALSE);
}

void CRingGroupDlg::ClearDlgAgentContent()
{
	m_ctrlListRingGroupAgent.ResetContent();
	m_sAgentName = "";

	UpdateData(FALSE);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupDlg::GetAgentNameAll(CStringList& objList)
{
	CString sMemberName;

	for(int nCount = 0; nCount < m_ctrlListRingGroupAgent.GetCount(); nCount++)
	{
		m_ctrlListRingGroupAgent.GetText(nCount, sMemberName);
		objList.AddTail(sMemberName);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupDlg::AddProcessMode()
{
	m_ctrlComboProcessMode.ResetContent();

	m_ctrlComboProcessMode.AddString(GROUP_PROCESS_MODE_RING_ALL);
	m_ctrlComboProcessMode.AddString(GROUP_PROCESS_MODE_HUNT_RANDOM);
	m_ctrlComboProcessMode.AddString(GROUP_PROCESS_MODE_ROUND_ROBIN);
	m_ctrlComboProcessMode.AddString(GROUP_PROCESS_MODE_LEAST_ANSWERED);
	m_ctrlComboProcessMode.AddString(GROUP_PROCESS_MODE_LEAST_TALK_TIME);
	m_ctrlComboProcessMode.AddString(GROUP_PROCESS_MODE_LONGEST_WAITING);
	m_ctrlComboProcessMode.AddString(GROUP_PROCESS_MODE_PRIORITIZED_HUNT);

	m_ctrlComboProcessMode.SetCurSel(0);

	UpdateData(FALSE);
}

void CRingGroupDlg::AddProcessType()
{
	m_ctrlComboProcessType.ResetContent();

	m_ctrlComboProcessType.AddString(GROUP_PROCESS_MODE_PROCESS_TYPE_FREE);
	m_ctrlComboProcessType.AddString(GROUP_PROCESS_MODE_PROCESS_TYPE_ANY);
	
	m_ctrlComboProcessType.SetCurSel(0);

	UpdateData(FALSE);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CRingGroupDlg::GetProcessMode()
{
	if(m_ctrlComboProcessMode.GetCurSel() == -1)
	{
		MessageBox("Select Process Mode");
		return -1;
	}

	return m_ctrlComboProcessMode.GetCurSel();
}

int CRingGroupDlg::GetProcessType()
{
 	if(m_ctrlComboProcessType.GetCurSel() == -1)
	{
		MessageBox("Select Process type");
		return -1;
	}

	return m_ctrlComboProcessType.GetCurSel();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupDlg::AddRingGroups()
{
	UpdateData();

	m_ctrlComboRingGroup.ResetContent();
	
	CStringList objList;
	CStoreRingGroup::GetGroupNameAll(objList);

	while(!objList.IsEmpty())
		m_ctrlComboRingGroup.AddString(objList.RemoveHead());

	if(m_ctrlComboRingGroup.GetCount() > 0)
		m_ctrlComboRingGroup.SetCurSel(0);
}

void CRingGroupDlg::AddUsers()
{
	m_ctrlComboAgents.ResetContent();

	CStringList objListUsers;
	CStoreUser::GetUserAll(objListUsers);

	if(objListUsers.IsEmpty()) return;

	while(!objListUsers.IsEmpty())
	{
		CString objLogin = objListUsers.RemoveHead();
		m_ctrlComboAgents.AddString(objLogin);
	}

	m_ctrlComboAgents.SetCurSel(0);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CRingGroupDlg::ShowRingGroupDetails()
{
	UpdateData();
	
	LONG nSelectedIndex = m_ctrlComboRingGroup.GetCurSel();
	if(nSelectedIndex == -1) return;

	CString sRingGroupName;
	m_ctrlComboRingGroup.GetLBText(nSelectedIndex, sRingGroupName);

	m_sRingGroupName = sRingGroupName;

	LONG nProcessMode, nProcessType;
	CStringList objAgentList;

	if(!CStoreRingGroup::GetGroup(m_sRingGroupName, nProcessMode, nProcessType, objAgentList))
		return;
	
	m_ctrlListRingGroupAgent.ResetContent();

	while(!objAgentList.IsEmpty())
		m_ctrlListRingGroupAgent.AddString(objAgentList.RemoveHead());

	m_ctrlComboProcessMode.GetLBText(nProcessMode, m_sProcessMode);
	m_ctrlComboProcessType.GetLBText(nProcessType, m_sProcessType);
	
	UpdateData(FALSE);
}

void CRingGroupDlg::OnCbnSelchangeComboRingGroup()
{
	ShowRingGroupDetails();
}
