#include "stdafx.h"
#include "VaxCallParking.h"
#include "VaxServerSIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LONG CVaxCallParking::m_nMusicCallParkingId = -1;

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

CVaxCallParking::CVaxCallParking(void)
{
}

CVaxCallParking::~CVaxCallParking(void)
{
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxCallParking::ResetAll(BOOL bAlloc, BOOL bDeAlloc)
{
	m_nMusicCallParkingId = -1;
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

BOOL CVaxCallParking::LoadMusic(LPCTSTR sFileName)
{
	if (m_nMusicCallParkingId != -1)
	{
		CVaxServerSIP::m_pVaxSIP->UnLoadWaveID(m_nMusicCallParkingId);
		m_nMusicCallParkingId = -1;
	}

    m_nMusicCallParkingId = CVaxServerSIP::m_pVaxSIP->LoadWaveFile(sFileName);
    return (m_nMusicCallParkingId != -1);
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxCallParking::OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LPCTSTR sRouteUID)
{
	StopMusic(nSessionId);
	CVaxServerSIP::m_pVaxSIP->AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, "", sRouteUID);
}

void CVaxCallParking::OnCallSessionTransferBlind(LONG nTransfererSessionId, LONG nTransfererChannelId, LPCTSTR sTransferee, LPCTSTR sTransferTo, LPCTSTR sRouteUID)
{
	if(!CVaxServerSIP::m_pVaxSIP->AcceptTransferBlind(nTransfererSessionId, sTransferee, sTransferee, sTransferTo, "", sRouteUID, 30))
		return;
	
	LONG nChannelId = VAX_CALL_CHANNEL_ZERO;
            
	if(nTransfererChannelId == VAX_CALL_CHANNEL_ZERO)
		nChannelId = VAX_CALL_CHANNEL_ONE;

	StartMusic(nTransfererSessionId, nChannelId);
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

BOOL CVaxCallParking::StartMusic(LONG nSessionId, LONG nChannelId)
{
	LONG nMusicId = CVaxCallParking::m_nMusicCallParkingId;

	if(nMusicId == -1)
		return FALSE;

	return CVaxServerSIP::m_pVaxSIP->PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, TRUE, 0);
}

void CVaxCallParking::StopMusic(LONG nSessionId)
{
	LONG nMusicId = CVaxCallParking::m_nMusicCallParkingId;

	if(nMusicId == -1)
		return;

	CVaxServerSIP::m_pVaxSIP->PlayWaveStopToCallSession(nSessionId, -1, -1);
}