#include "stdafx.h"
#include "VaxServerSIP.h"
#include "VaxCall.h"
#include "VaxUser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxCall::CVaxCall(void)
{
}

CVaxCall::~CVaxCall(void)
{
}

void CVaxCall::OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sToPeerName, BOOL& bProcessed)
{
	bProcessed = FALSE;

	if(CString(sDialNo).IsEmpty() || (CString(sToPeerName).IsEmpty()))
	{
		return;
	}
			
	if(!CVaxServerSIP::m_pVaxSIP->AcceptCallSession(nSessionId, "", "", sDialNo, sToPeerName, ""))
	{
		CVaxServerSIP::m_pVaxSIP->RejectCallSession(nSessionId, 404, "Not Found");
		return;
	}

	AdjustVoiceType(nSessionId, TRUE, sFromPeerName);
	AdjustVoiceType(nSessionId, FALSE, sToPeerName);

	//CVaxServerSIP::m_pVaxSIP->DetectDigitDTMF(nSessionId, VAX_CALL_CHANNEL_ZERO, VAX_DTMF_TYPE_RFC2833, TRUE, 2000);
	//CVaxServerSIP::m_pVaxSIP->RecordWaveStartToCallSession(nSessionId, VAX_CALL_CHANNEL_ZERO, "Record.wav");

	bProcessed = TRUE;
}

void CVaxCall::AdjustVoiceType(LONG nSessionId, BOOL bIsInboundCall, LPCTSTR sPeerName)
{
	LONG nChannelId = VAX_CALL_CHANNEL_ZERO;

	if (bIsInboundCall)
		nChannelId = VAX_CALL_CHANNEL_ZERO;
	else
		nChannelId = VAX_CALL_CHANNEL_ONE;

	//////////////////////////////////////////////////////////////////////////////////

	int nVoiceType = CVaxUser::GetVoiceTypeId(sPeerName);

	if (nVoiceType == VAX_AUDIO_TYPE_ADMIN)     // Admin-Type can only listen to Normal-Type's voice, so adjust voice type from Admin-Type to User-Type. User-Type can speak and listen (both) to Normal-Type.
		nVoiceType = VAX_AUDIO_TYPE_USER;       // Admin-Type (voice) can be used in call-center for training sessions or stealth listening.

	CVaxServerSIP::m_pVaxSIP->AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceType);
}