#include "stdafx.h"
#include "VaxCallSession.h"
#include "VaxCallSessionList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxCallSessionList::CVaxCallSessionList()
{
	m_objSessionList.InitHashTable(4096, TRUE);
}

CVaxCallSessionList::~CVaxCallSessionList()
{
	ClearAll();
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

CVaxCallSession* CVaxCallSessionList::Find(LONG nSessionId)
{
	CVaxCallSession* pData = NULL;
	
	if(!m_objSessionList.Lookup(nSessionId, pData))
		return NULL;

	return pData;
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

BOOL CVaxCallSessionList::AddSession(LONG nSessionId, CVaxCallSession* pData)
{
	RemoveSession(nSessionId);
	
	m_objSessionList.SetAt(nSessionId, pData);
	return TRUE;
}

void CVaxCallSessionList::RemoveSession(LONG nSessionId)
{
	CVaxCallSession* pData = Find(nSessionId);
	if(pData == NULL) return;
		
	m_objSessionList.RemoveKey(nSessionId);
	delete pData;
}

CVaxCallSession* CVaxCallSessionList::GetSession(LONG nSessionId)
{
	CVaxCallSession* pData = Find(nSessionId);
	if(pData == NULL) return NULL;

	return pData;
}

BOOL CVaxCallSessionList::IsExist(LONG nSessionId)
{
	CVaxCallSession* pData = Find(nSessionId);
	if(pData == NULL) return FALSE;

	return TRUE;
}

void CVaxCallSessionList::ClearAll()
{
	LONG nSessionId = -1;
	CVaxCallSession* pData = NULL;
	
	for(POSITION hPos = m_objSessionList.GetStartPosition(); hPos != NULL;)
	{
		m_objSessionList.GetNextAssoc(hPos, nSessionId, pData);
		delete pData;
	}

	m_objSessionList.RemoveAll();
}