#pragma once

////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

class CUserRouteDetails : public CVaxHashTextData
{

public:

	CString m_sUserPrefix, m_sToPeerName, m_sDialPrefix;

public:

	CUserRouteDetails(){};
	~CUserRouteDetails(){};
};

////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

class CLineRouteDetails : public CVaxHashTextData
{

public:

	CString m_sLineName; 
	CString m_sRoomName;

	CString m_sQueueName;
	CString m_sRingGroupName;

	CString m_sToPeerName;
	BOOL m_bRejected;
	
public:

	CLineRouteDetails(){};
	~CLineRouteDetails(){};
};

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

class CVaxServerExCOM;

class CVaxCallSessionRoute
{
	 
public:

	CVaxCallSessionRoute();
	~CVaxCallSessionRoute();

private:

	CVaxHashText* m_pUserRouteList;
	CVaxHashText* m_pLineRouteList;

private:

	CUserRouteDetails* FindUserRoute(LPCTSTR sUserName);
	CLineRouteDetails* FindLineRoute(LPCTSTR sLineName);
			
	BOOL GetUserRouteDetails(LPCTSTR sUserName, CString& sUserPrefix, CString& sDialPrefix, CString& sToPeerName);
	BOOL GetLineRouteDetails(LPCTSTR sLineName, CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);

public:

	void AddUserRoute(LPCTSTR sUserName, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, LPCTSTR sToPeerName);
	void RemoveUserRoute(LPCTSTR sUserName);

	void AddLineRoute(LPCTSTR sLineName, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveLineRoute(LPCTSTR sLineName);
	
public:

	BOOL GetUserRouteInfo(LPCTSTR sUserName, LPCTSTR sUserDialedNo, CString& sDialToNo, CString& sToPeerName);
	void GetLineRouteInfo(LPCTSTR sLineName, LPCTSTR sDialNo, CString& sDialToNo, CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);
};

