#include "StdAfx.h"
#include "Define.h"
#include "VaxLine.h"

#include "VaxServerSIP.h"
#include "VaxCallSession.h"
#include "StoreLine.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxLine::CVaxLine()
{
}

CVaxLine::~CVaxLine()
{
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void CVaxLine::OnLineRegisterTrying(LPCTSTR sLineName)
{
	CString sStatus = sLineName + CString(" ") + LINE_REG_TRYING;
    CVaxServerSIP::m_pVaxSIP->GenStatusLog(sStatus);
}

void CVaxLine::OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	CString sStatus = sLineName + CString(" Register Failed: ") + sReasonPhrase;
    CVaxServerSIP::m_pVaxSIP->GenStatusLog(sStatus);
}

void CVaxLine::OnLineRegisterSuccess(LPCTSTR sLineName)
{
	CString sStatus = sLineName + CString(" ") + LINE_REG_SUCCESS;
    CVaxServerSIP::m_pVaxSIP->GenStatusLog(sStatus);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL CVaxLine::AddLine(LPCTSTR sLineName, LONG nLineType, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList, BOOL bRegister, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName)
{
	RemoveLine(sLineName);
	
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sLineName).IsEmpty())
		return FALSE;

	BOOL bResult = CVaxServerSIP::m_pVaxSIP->AddLine(sLineName, nLineType, "", "", sAuthUser, sAuthPwd, "", sServerAddr, nServerPort, sAudioCodecList);
	if(!bResult) return FALSE;
	
	CVaxCallSession::AddLineRoute(sLineName, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
	
	if(bRegister)
		CVaxServerSIP::m_pVaxSIP->RegisterLine(sLineName, 1800);
			
	CStoreLine::AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
	return TRUE;
}

void CVaxLine::RemoveLine(LPCTSTR sLineName)
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sLineName).IsEmpty())
		return;
		    
	CVaxServerSIP::m_pVaxSIP->RemoveLine(sLineName);
	CVaxCallSession::RemoveLineRoute(sLineName);

	CStoreLine::RemoveLine(sLineName);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void CVaxLine::LoadLine()
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized())
		return;

	CStringList objListLine;
	CStoreLine::GetLineNameAll(objListLine);

	if(objListLine.IsEmpty())
		return;

	CString sLineName, sAuthUser, sAuthPwd, sServerAddr, sAudioCodecList;
	CString sToPeerName, sRoomName, sQueueName, sRingGroupName;

	BOOL bRejected = FALSE, bRegister = FALSE;
	LONG nLineType = VAX_LINE_TYPE_UDP, nServerPort = SIP_DEFAULT_PORT;
					
	while(!objListLine.IsEmpty())
	{
		sLineName = objListLine.RemoveHead();
				
		CStoreLine::GetLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
		AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
	}
}
