#include "stdafx.h"
#include "VaxServerSIP.h"
#include "VaxCallPickUp.h"
#include "StoreCallPickUp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxCallPickUp::CVaxCallPickUp(void)
{
}

CVaxCallPickUp::~CVaxCallPickUp(void)
{
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

BOOL CVaxCallPickUp::AddCallPickUpGroup(LPCTSTR sGroupName, CStringList& objMemberList)
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sGroupName).IsEmpty())
		return FALSE;
	
	RemoveCallPickUpGroup(sGroupName);

	if (!CVaxServerSIP::m_pVaxSIP->AddCallPickUpGroup(sGroupName))
		return FALSE;
	            
	POSITION hPos = objMemberList.GetHeadPosition();

	while(hPos != NULL)
	{
		CString sMemberName = objMemberList.GetNext(hPos);
		CVaxServerSIP::m_pVaxSIP->AddCallPickUpGroupMember(sGroupName, sMemberName);
	}

	CStoreCallPickUp::AddGroup(sGroupName, objMemberList);
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxCallPickUp::RemoveCallPickUpGroup(LPCTSTR sGroupName)
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sGroupName).IsEmpty())
		return;

	CVaxServerSIP::m_pVaxSIP->RemoveCallPickUpGroup(sGroupName);
	CStoreCallPickUp::RemoveGroup(sGroupName);
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxCallPickUp::LoadCallPickupGroup()
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized())
		return;

	CStringList objListCallPickUp;
	CStoreCallPickUp::GetGroupNameAll(objListCallPickUp);

	if(objListCallPickUp.IsEmpty())
		return;

	CStringList objMemberList;
	CString sGroupName;
	
	while(!objListCallPickUp.IsEmpty())
	{
		sGroupName = objListCallPickUp.RemoveHead();

		CStoreCallPickUp::GetGroup(sGroupName, objMemberList);
		AddCallPickUpGroup(sGroupName, objMemberList);
   }
}