#include "stdafx.h"
#include "VaxServerSIP.h"
#include "VaxRingGroup.h"
#include "StoreRingGroup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxRingGroup::CVaxRingGroup(void)
{
}


CVaxRingGroup::~CVaxRingGroup(void)
{
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxRingGroup::OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sRingGroupName, BOOL& bProcessed)
{
	bProcessed = FALSE;

	if(CString(sRingGroupName).IsEmpty())
		return;
		
	if(!CVaxServerSIP::m_pVaxSIP->AddCallSessionToRingGroup(sRingGroupName, sCallerName, sCallerId, nSessionId))
		return;

	bProcessed = TRUE;
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

BOOL CVaxRingGroup::AddRingGroup(LPCTSTR sGroupName, LONG nProcessMode, LONG nProcessType, CStringList& objAgentList)
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sGroupName).IsEmpty())
		return FALSE;
	
	RemoveRingGroup(sGroupName);

	if (!CVaxServerSIP::m_pVaxSIP->AddRingGroup(sGroupName))
		return FALSE;

	POSITION hPos = objAgentList.GetHeadPosition();

	while(hPos != NULL)
	{
		CString sAgentName = objAgentList.GetNext(hPos);
		CVaxServerSIP::m_pVaxSIP->AddRingGroupAgent(sGroupName, sAgentName);
	}
	          
	CVaxServerSIP::m_pVaxSIP->SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType);
	CStoreRingGroup::AddGroup(sGroupName, nProcessMode, nProcessType, objAgentList);

    return TRUE;
}

void CVaxRingGroup::RemoveRingGroup(LPCTSTR sGroupName)
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sGroupName).IsEmpty())
		return;

	CVaxServerSIP::m_pVaxSIP->RemoveRingGroup(sGroupName);
	CStoreRingGroup::RemoveGroup(sGroupName);
}


//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxRingGroup::LoadRingGroup()
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized())
		return;

	CStringList objListRingGroup;
	CStoreRingGroup::GetGroupNameAll(objListRingGroup);

	if(objListRingGroup.IsEmpty())
		return;

	CStringList objAgentList;

	CString sRingGroupName;
    LONG nProcessMode = -1, nProcessType = -1;
	
	while(!objListRingGroup.IsEmpty())
	{
		sRingGroupName = objListRingGroup.RemoveHead();
	   
		CStoreRingGroup::GetGroup(sRingGroupName, nProcessMode, nProcessType, objAgentList);
		AddRingGroup(sRingGroupName, nProcessMode, nProcessType, objAgentList);
	}
}