#include "stdafx.h"
#include "VaxServerSIP.h"
#include "VaxRoom.h"
#include "StoreRoom.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

CVaxRoom::CVaxRoom(void)
{
}

CVaxRoom::~CVaxRoom(void)
{
}

///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

void CVaxRoom::OnIncomingCall(LONG nSessionId, LPCTSTR sRoomName, BOOL& bProcessed)
{
	bProcessed = FALSE;

	if(CString(sRoomName).IsEmpty())
		return;

	if(!CVaxServerSIP::m_pVaxSIP->AddCallSessionToConferenceRoom(sRoomName, nSessionId))
	{
		CVaxServerSIP::m_pVaxSIP->RejectCallSession(nSessionId, 404, "Not Found");
		return;
	}

	if(!CVaxServerSIP::m_pVaxSIP->AcceptCallSession(nSessionId, "", "", "", "", "")) // Accept incoming call and add to conference room.
	{
		CVaxServerSIP::m_pVaxSIP->RejectCallSession(nSessionId, 404, "Not Found");
		return;
	}
		
	bProcessed = TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
	
BOOL CVaxRoom::AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo)
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sRoomName).IsEmpty() || CString(sRoomNo).IsEmpty())
		return FALSE;

	RemoveRoom(sRoomName);

    if (!CVaxServerSIP::m_pVaxSIP->OpenConferenceRoom(sRoomName))
	{
		RemoveRoom(sRoomName);
		return FALSE;
	}
		
	if (!CVaxServerSIP::m_pVaxSIP->AddConferenceRoomRouteUID(sRoomName, sRoomNo))
	{
		RemoveRoom(sRoomName);
		return FALSE;
	}
		
	CStoreRoom::AddRoom(sRoomName, sRoomNo);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

void CVaxRoom::RemoveRoom(LPCTSTR sRoomName)
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized() || CString(sRoomName).IsEmpty())
		return;

	CVaxServerSIP::m_pVaxSIP->CloseConferenceRoom(sRoomName);
	CStoreRoom::RemoveRoom(sRoomName);
}

///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

void CVaxRoom::LoadRoom()
{
	if(!CVaxServerSIP::m_pVaxSIP->IsInitialized())
		return;
	
	CStringList objListRoomName;
	CStoreRoom::GetRoomNameAll(objListRoomName);

	if(objListRoomName.IsEmpty())
		return;

	CString sRoomNo;
	
	while(!objListRoomName.IsEmpty())
	{
		CString sRoomName = objListRoomName.RemoveHead();

		CStoreRoom::GetRoom(sRoomName, sRoomNo);
		AddRoom(sRoomName, sRoomNo);
	}
}
