#include "stdafx.h"

#include "VaxServerSIP.h"
#include "StatusLogDlg.h"

#include "StoreCOMM.h"
#include "StoreUser.h"
#include "StoreLine.h"

#include "StoreRoom.h"
#include "StoreRingGroup.h"
#include "StoreQueue.h"
#include "StoreCallPickUp.h"

#include "VaxSettingDefault.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxServerSIP* CVaxServerSIP::mVaxSIP = NULL;

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

CVaxServerSIP::CVaxServerSIP()
{
	CVaxServerSIP::mVaxSIP = this;
}

CVaxServerSIP::~CVaxServerSIP()
{
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

BOOL CVaxServerSIP::StartServer(LONG nListenPort)
{
	if(!CStoreCOMM::SetListenPortSIP(nListenPort))
		return FALSE;

	return CVaxServerExCOM::Initialize(nListenPort);
}

void CVaxServerSIP::StopServer()
{
   CVaxServerExCOM::UnInitialize();
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

LONG CVaxServerSIP::GetCallCount()
{
	return CVaxServerExCOM::GetCallCount();
}

LONG CVaxServerSIP::GetRegisteredUserCount()
{
	return CVaxServerExCOM::GetRegisteredUserCount();
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

LONG CVaxServerSIP::GetListenPortSIP()
{
	return CStoreCOMM::GetListenPortSIP();
}

void CVaxServerSIP::LoadMusicFiles(LPCTSTR sMusicHold, LPCTSTR sMusicDialTone, LPCTSTR sMusicCallPark)
{
	CVaxServerExCOM::LoadMusicHold(sMusicHold);
    CVaxServerExCOM::LoadMusicDialTone(sMusicDialTone);
    CVaxServerExCOM::LoadMusicCallPark(sMusicCallPark);
            
	CStoreCOMM::SetMusicFiles(sMusicHold, sMusicDialTone, sMusicCallPark);
}

void CVaxServerSIP::GetMusicFiles(CString& sMusicHold, CString& sMusicDialTone, CString& sMusicCallPark)
{
	CStoreCOMM::GetMusicFiles(sMusicHold, sMusicDialTone, sMusicCallPark);
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

//BOOL CVaxServerSIP::AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sAudioCodecList, BOOL bBlocked, LONG nVoiceTypeId, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, LPCTSTR sToPeerName)
//{
//	RemoveUser(sUserName);
//	
//	if(!CVaxServerExCOM::IsInitialized() || CString(sUserName).IsEmpty())
//		return FALSE;
//	
//	CStoreUser::AddUser(sUserName, sPassword, sAudioCodecList, bBlocked, nVoiceTypeId, sUserPrefix, sDialPrefix, sToPeerName);
//	return CVaxServerExCOM::AddUser(sUserName, sPassword, sAudioCodecList, bBlocked, nVoiceTypeId, sUserPrefix, sDialPrefix, sToPeerName);
//}
//
//void CVaxServerSIP::RemoveUser(LPCTSTR sUserName)
//{
//	if(!CVaxServerExCOM::IsInitialized())
//	   return;
//
//	if(CString(sUserName).IsEmpty())
//    	return;
//		
//	CStoreUser::RemoveUser(sUserName);
//	CVaxServerExCOM::RemoveUser(sUserName);
//}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

//BOOL CVaxServerSIP::AddLine(LPCTSTR sLineName, LONG nLineType, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList, BOOL bRegister, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName)
//{
//	RemoveLine(sLineName);
//	
//	if(!CVaxServerExCOM::IsInitialized())
//		return FALSE;
//		
//	CStoreLine::AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
//	return CVaxServerExCOM::AddLine(sLineName, nLineType, sAuthUser, sAuthPwd, sServerAddr, nServerPort, sAudioCodecList, bRegister, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
//}
//
//void CVaxServerSIP::RemoveLine(LPCTSTR sLineName)
//{
//	if(!CVaxServerExCOM::IsInitialized())
//		return;
//
//	CStoreLine::RemoveLine(sLineName);
//    CVaxServerExCOM::RemoveLine(sLineName);
//}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

BOOL CVaxServerSIP::AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo)
{
	if(!CVaxServerExCOM::IsInitialized())
		return FALSE;
	
	RemoveRoom(sRoomName);

	if(!CVaxServerExCOM::AddRoom(sRoomName, sRoomNo))
		return FALSE;
		
    CStoreRoom::AddRoom(sRoomName, sRoomNo);
	return TRUE;
}

void CVaxServerSIP::RemoveRoom(LPCTSTR sRoomName)
{
    if(!CVaxServerExCOM::IsInitialized())
		return;
	
    CStoreRoom::RemoveRoom(sRoomName);
	CVaxServerExCOM::RemoveRoom(sRoomName);
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

BOOL CVaxServerSIP::AddQueue(LPCTSTR sQueueName, LONG nProcessMode, LONG nProcessType, CStringList& objAgentList, LPCTSTR sMusicFileName, LPCTSTR sDialToneFileName)
{
	if(!CVaxServerExCOM::IsInitialized())
		return FALSE;

	if(CString(sQueueName).IsEmpty())
    	return FALSE;
		
	if(!CVaxServerExCOM::AddQueue(sQueueName, nProcessMode, nProcessType, objAgentList, sMusicFileName, sDialToneFileName))
		return FALSE;
		
	CStoreQueue::AddQueue(sQueueName, nProcessMode, nProcessType, objAgentList, sMusicFileName, sDialToneFileName);
	return TRUE;	
}

void CVaxServerSIP::RemoveQueue(LPCTSTR sQueueName)
{
	if(!CVaxServerExCOM::IsInitialized())
		return;

	if(CString(sQueueName).IsEmpty())
    	return;

	CStoreQueue::RemoveQueue(sQueueName);
	CVaxServerExCOM::RemoveQueue(sQueueName);
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

BOOL CVaxServerSIP::AddCallPickUpGroup(LPCTSTR sGroupName, CStringList& objMemberList)
{
	if(!CVaxServerExCOM::IsInitialized())
		return FALSE;

	if(CString(sGroupName).IsEmpty())
    	return FALSE;
		
	if(!CVaxServerExCOM::AddCallPickUpGroup(sGroupName, objMemberList))
		return FALSE;
		
	CStoreCallPickUp::AddGroup(sGroupName, objMemberList);
	return TRUE;	
}

void CVaxServerSIP::RemoveCallPickUpGroup(LPCTSTR sGroupName)
{
	if(!CVaxServerExCOM::IsInitialized())
		return;

	if(CString(sGroupName).IsEmpty())
    	return;

	CVaxServerExCOM::RemoveCallPickUpGroup(sGroupName);
	CStoreCallPickUp::RemoveGroup(sGroupName);
}

////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////



void CVaxServerSIP::LoadQueue()
{
	if(!CVaxServerExCOM::IsInitialized())
		return;

	CStringList objListQueue;
	CStoreQueue::GetQueueNameAll(objListQueue);

	if(objListQueue.IsEmpty())
		return;

	CStringList objAgentList;
	
	CString sQueueName, sMusicFileName, sDialToneFileName;
	LONG nProcessMode = -1, nProcessType = -1;
		
	while(!objListQueue.IsEmpty())
	{
		sQueueName = objListQueue.RemoveHead();
	   
		CStoreQueue::GetQueue(sQueueName, nProcessMode, nProcessType, objAgentList, sMusicFileName, sDialToneFileName);
		CVaxServerExCOM::AddQueue(sQueueName, nProcessMode, nProcessType, objAgentList, sMusicFileName, sDialToneFileName);
   }
}





/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

void CVaxServerSIP::OnInitialize()
{
	if(!CVaxSettingDefault::LoadUserDefault())
	{
		LoadUser();
	}
	
	if(!CVaxSettingDefault::LoadLineDefault())
	{
		LoadLine();
	}
	
	if(!CVaxSettingDefault::LoadRoomDefault())
	{
		LoadRoom();
	}
    
	if(!CVaxSettingDefault::LoadQueueDefault())
	{
		LoadQueue();
	}

	if(!CVaxSettingDefault::LoadRingGroupDefault())
	{
		LoadRingGroup();
	}

	if(!CVaxSettingDefault::LoadCallPickUpGroupDefault())
	{
		LoadCallPickupGroup();
	}
}

void CVaxServerSIP::OnStatusLog(LPCTSTR sStatus)
{
	m_pStatusLogDlg->OnStatusLog(sStatus);
}