#pragma once

#include "VaxServerCOM.h"

class CStatusLogDlg;
class CVaxSettingDefault;

class CVaxServerSIP : public CVaxServerCOM
{

public:

	CStatusLogDlg* m_pStatusLogDlg;

public:

	CVaxServerSIP();
	~CVaxServerSIP();

public:

	static CVaxServerSIP* mVaxSIP;

public:

	BOOL StartServer(LONG nListenPort);
	void StopServer();

	LONG GetCallCount();
	LONG GetRegisteredUserCount();

	LONG GetListenPortSIP();

	void LoadMusicFiles(LPCTSTR sMusicHold, LPCTSTR sMusicDialTone, LPCTSTR sMusicCallPark);
	void GetMusicFiles(CString& sMusicHold, CString& sMusicDialTone, CString& sMusicCallPark);

public:

	BOOL AddLine(LPCTSTR sLineName, LONG nLineType, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sServerAddr, LONG nServerPort, LPCTSTR sAudioCodecList, BOOL bRegister, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveLine(LPCTSTR sLineName);
		
public:

	BOOL AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo);
	void RemoveRoom(LPCTSTR sRoomName);
	
public:

	BOOL AddQueue(LPCTSTR sQueueName, LONG nProcessMode, LONG nProcessType, CStringList& objAgentList, LPCTSTR sMusicFileName, LPCTSTR sDialToneFileName);
	void RemoveQueue(LPCTSTR sQueueName);
		
public:

	BOOL AddRingGroup(LPCTSTR sGroupName, LONG nProcessMode, LONG nProcessType, CStringList& objAgentList);
    void RemoveRingGroup(LPCTSTR sGroupName);
	
public:

	BOOL AddCallPickUpGroup(LPCTSTR sGroupName, CStringList& objMemberList);
	void RemoveCallPickUpGroup(LPCTSTR sGroupName);
			
private:

	void LoadUser();
	void LoadLine();
	
	void LoadRoom();
	void LoadQueue();

	void LoadRingGroup();
	void LoadCallPickupGroup();
	
private:

	void OnInitialize();
	void OnStatusLog(LPCTSTR sMsg);
};

