#pragma once

#include "VaxServerCOM.h"

class CStatusLogDlg;
class CVaxCallSessionList;

class CVaxServerSIP : public CVaxServerCOM
{

public:
	
	CVaxServerSIP();
	~CVaxServerSIP();

public:

	CStatusLogDlg* m_pStatusLogDlg;

public:
		
	static CVaxServerSIP* m_pVaxSIP;

private:

	BOOL m_bInitialized;
	LONG m_nDialToneId;

private:
	
	CVaxCallSessionList* m_pSessionList;
						
private:

	void ResetAll(BOOL bAlloc, BOOL bDeAlloc);

public:
					
	BOOL StartServer(LONG nListenPort);
	void StopServer();
	
	BOOL IsInitialized();
	BOOL AcceptCallSession(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LPCTSTR sToPeerName, LPCTSTR sRouteUID);
	
	BOOL DialToneToCallSession(BOOL bEnable, LONG nSessionId);
				
private:
	
	BOOL LoadMusicDialTone(LPCTSTR sFileName);
		
public:

	void LoadMusicFiles(LPCTSTR sMusicHold, LPCTSTR sMusicDialTone, LPCTSTR sMusicCallPark);
	void GenStatusLog(LPCTSTR sStatus);
					
private:

	void OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	void OnUnRegisterUser(LPCTSTR sUserLogin);

	void OnCallSessionCreated(LONG nSessionId, LONG nReasonCode);
	void OnCallSessionClosed(LONG nSessionId, LONG nChannelId, LONG nReasonCode);
	
	void OnCallSessionPushSIP(LONG nSessionId, LONG nChannelId, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG nProviderPN, LPCTSTR sProjectPN, LPCTSTR sDevicePN);
	void OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sRouteUID, LONG nRouteType, LPCTSTR sRouteName, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort);

	void OnCallSessionTransferBlind(LONG nTransfererSessionId, LONG nTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo, LPCTSTR sRouteUID, LONG nRouteType, LPCTSTR sRouteName);
	void OnCallSessionTransferConsult(LONG nTransfererSessionId, LONG nTransfereeSessionId, LONG nTransferToSessionId, LONG nTransfererChannelId, LONG nTransfereeChannelId, LONG nTransferToChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
		
	void OnLineRegisterTrying(LPCTSTR sLineName);
	void OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase);
	void OnLineRegisterSuccess(LPCTSTR sLineName);
			
	void OnChatMessageText(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	void OnChatMessageTyping(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, BOOL bIsTypingStart, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	void OnChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort);
	
	void OnDetectedDigitDTMF(LONG nSessionId, LONG nChannelId, LPCTSTR sDigitDTMF, int nTypeDTMF);
	void OnCallSessionDetectedAMD(LONG nSessionId, LONG nChannelId, BOOL bIsHuman);
		
	void OnBusyLampSubscribe(LONG nSubscrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort);
	void OnBusyLampSendStatus(LPCTSTR sFromUserName, LPCTSTR sToUserName, LONG nStateId);

	void OnCallSessionErrorLog(LONG nSessionId, LONG nChannelId, LONG nErrorCode, LPCTSTR sErrorMsg);
	void OnVaxErrorLog(LPCTSTR sFuncName, LONG nErrorCode, LPCTSTR sErrorMsg);
	
	void OnQueuePlayWaveStarted(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);
	void OnQueuePlayWaveEnded(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);

	void OnStealthListenerAttached(LONG nAttachType, LONG nStealthSessionId, LONG nAttachSessionId, LONG nAttachChannelId);
	
protected:

	void OnInitialize();
	void OnStatusLog(LPCTSTR sMsg);
};


