#include "stdafx.h"
#include "VaxServerSIP.h"

#include "VaxUser.h"
#include "VaxLine.h"
#include "VaxQueue.h"
#include "VaxCallPickUp.h"
#include "VaxRoom.h"
#include "VaxRingGroup.h"

#include "StoreRegistry.h"
#include "StoreCOMM.h"
#include "StoreUser.h"
#include "StoreLine.h"

#include "StoreRoom.h"
#include "StoreRingGroup.h"
#include "StoreQueue.h"
#include "StoreCallPickUp.h"
#include "VaxSettingDefault.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL CVaxSettingDefault::LoadUserDefault()
{
	if(CStoreUser::IsDataStored())
		return FALSE;
	
	for(LONG nCount = 4000; nCount <= 4050; nCount++)
	{
		CString sLogin;
		sLogin.Format("%d", nCount);

		CVaxUser::AddUser(sLogin, sLogin, "32014", FALSE, VAX_AUDIO_TYPE_NORMAL, "", "", "");
	}

	for(LONG nCount = 6000; nCount <= 6020; nCount++)
	{
		CString sLogin;
		sLogin.Format("%d", nCount);

		CVaxUser::AddUser(sLogin, sLogin, "32014", FALSE, VAX_AUDIO_TYPE_USER, "", "", "");
	}

	for(LONG nCount = 8000; nCount <= 8020; nCount++)
	{
		CString sLogin;
		sLogin.Format("%d", nCount);

		CVaxUser::AddUser(sLogin, sLogin, "32014", FALSE, VAX_AUDIO_TYPE_ADMIN, "", "", "");
	}
	
	return TRUE;
}

BOOL CVaxSettingDefault::LoadQueueDefault()
{
	if(CStoreQueue::IsDataStored())
		return FALSE;
	
	CStringList objAgentList;

	objAgentList.AddTail("6000");
	objAgentList.AddTail("6001");
	objAgentList.AddTail("6002");
	objAgentList.AddTail("6003");
	objAgentList.AddTail("6004");
	objAgentList.AddTail("6005");

	CVaxQueue::AddQueue("QueueTech", VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN, VAX_QUEUE_PROCESS_TYPE_FREE, objAgentList, MUSIC_FILE_QUEUE, MUSIC_FILE_DIAL_TONE);

	objAgentList.RemoveAll();

	objAgentList.AddTail("6010");
	objAgentList.AddTail("6011");
	objAgentList.AddTail("6012");
	objAgentList.AddTail("6013");
	objAgentList.AddTail("6014");
	objAgentList.AddTail("6015");

	CVaxQueue::AddQueue("QueueSales", VAX_QUEUE_PROCESS_MODE_HUNT_RANDOM, VAX_QUEUE_PROCESS_TYPE_FREE, objAgentList, MUSIC_FILE_QUEUE, MUSIC_FILE_DIAL_TONE);
	
	return TRUE;
}

BOOL CVaxSettingDefault::LoadRingGroupDefault()
{
	if(CStoreRingGroup::IsDataStored())
		return FALSE;
		
	CStringList objAgentList;

	objAgentList.AddTail("4000");
	objAgentList.AddTail("4001");
	objAgentList.AddTail("4002");
	objAgentList.AddTail("4003");
	objAgentList.AddTail("4004");
	objAgentList.AddTail("4005");

	CVaxRingGroup::AddRingGroup("RingGroupTech", VAX_RING_GROUP_PROCESS_MODE_RING_ALL, VAX_RING_GROUP_PROCESS_TYPE_FREE, objAgentList);
	
	objAgentList.RemoveAll();

	objAgentList.AddTail("4010");
	objAgentList.AddTail("4011");
	objAgentList.AddTail("4012");
	objAgentList.AddTail("4013");
	objAgentList.AddTail("4014");
	objAgentList.AddTail("4015");

    CVaxRingGroup::AddRingGroup("RingGroupDesign", VAX_RING_GROUP_PROCESS_MODE_HUNT_RANDOM, VAX_RING_GROUP_PROCESS_TYPE_FREE, objAgentList);
			
	return TRUE;
}

BOOL CVaxSettingDefault::LoadCallPickUpGroupDefault()
{
	if(CStoreCallPickUp::IsDataStored())
		return FALSE;

	CStringList objMemberList;

	objMemberList.AddTail("4000");
	objMemberList.AddTail("4001");
	objMemberList.AddTail("4002");
	objMemberList.AddTail("4003");
	objMemberList.AddTail("4004");
	objMemberList.AddTail("4005");
				
	CVaxCallPickUp::AddCallPickUpGroup("PickUpTech", objMemberList);
	
	objMemberList.RemoveAll();

	objMemberList.AddTail("4010");
	objMemberList.AddTail("4011");
	objMemberList.AddTail("4012");
	objMemberList.AddTail("4013");
	objMemberList.AddTail("4014");
	objMemberList.AddTail("4015");

	CVaxCallPickUp::AddCallPickUpGroup("PickUpDesign", objMemberList);
	
	return TRUE;
}

BOOL CVaxSettingDefault::LoadLineDefault()
{
	if(CStoreLine::IsDataStored())
		return FALSE;
		
	CVaxLine::AddLine("LineServiceProviderTech", VAX_LINE_TYPE_UDP, "9090", "9090", "192.168.0.119", 5060, "32", FALSE, "", FALSE, "", "QueueTech", "");
	CVaxLine::AddLine("LineServiceProviderDesign", VAX_LINE_TYPE_UDP, "9092", "9092", "192.168.0.119", 5060, "32", FALSE, "", FALSE, "", "QueueSales", "");
	
	return TRUE;
}

BOOL CVaxSettingDefault::LoadRoomDefault()
{
	if(CStoreRoom::IsDataStored())
		return FALSE;
	
	CStoreRoom::AddRoom("RoomTech", "20021");
	CStoreRoom::AddRoom("RoomDesign", "20022");
	
	return TRUE;
}