#include "stdafx.h"
#include "VaxStealthListen.h"
#include "VaxServerSIP.h"
#include "VaxUser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LONG CVaxStealthListen::m_nMusicWaitingStealthListenId = -1;

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

CVaxStealthListen::CVaxStealthListen(void)
{
}

CVaxStealthListen::~CVaxStealthListen(void)
{
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxStealthListen::ResetAll(BOOL bAlloc, BOOL bDeAlloc)
{
	m_nMusicWaitingStealthListenId = -1;
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

BOOL CVaxStealthListen::LoadMusic(LPCTSTR sFileName)
{
	if (m_nMusicWaitingStealthListenId != -1)
	{
		CVaxServerSIP::m_pVaxSIP->UnLoadWaveID(m_nMusicWaitingStealthListenId);
		m_nMusicWaitingStealthListenId = -1;
	}

    m_nMusicWaitingStealthListenId = CVaxServerSIP::m_pVaxSIP->LoadWaveFile(sFileName);

    return (m_nMusicWaitingStealthListenId != -1);
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void CVaxStealthListen::OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sRouteUID)
{
	if(nFromPeerType != VAX_PEER_TYPE_USER || CVaxUser::IsUserTypeAdmin(sFromPeerName) == FALSE)
	{
		CVaxServerSIP::m_pVaxSIP->RejectCallSession(nSessionId, 403, "Forbidden");
		return;
	}

	CVaxServerSIP::m_pVaxSIP->AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, "", sRouteUID);
	CVaxServerSIP::m_pVaxSIP->AdjustCallSessionVoiceType(nSessionId, -1, VAX_AUDIO_TYPE_ADMIN);

	StartMusic(nSessionId, VAX_CALL_CHANNEL_ZERO);
}

void CVaxStealthListen::OnStealthListenerAttached(LONG nAttachType, LONG nStealthSessionId, LONG nAttachSessionId, LONG nAttachChannelId)
{
	if (nAttachType == VAX_STEALTH_LISTENER_FREE)
	{
		StartMusic(nStealthSessionId, VAX_CALL_CHANNEL_ZERO);
	}

	else if (nAttachType == VAX_STEALTH_LISTENER_BUSY)
	{
		StopMusic(nStealthSessionId);
	}
}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

BOOL CVaxStealthListen::StartMusic(LONG nSessionId, LONG nChannelId)
{
	LONG nMusicId = CVaxStealthListen::m_nMusicWaitingStealthListenId;

	if(nMusicId == -1)
		return FALSE;

	return CVaxServerSIP::m_pVaxSIP->PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, TRUE, 0);
}

void CVaxStealthListen::StopMusic(LONG nSessionId)
{
	LONG nMusicId = CVaxStealthListen::m_nMusicWaitingStealthListenId;

	if(nMusicId == -1)
		return;

	CVaxServerSIP::m_pVaxSIP->PlayWaveStopToCallSession(nSessionId, -1, -1);
}