
#pragma once

class CVaxUserList;

class CVaxUser : public CVaxHashTextData
{

public:

	CVaxUser(LPCTSTR sUserName, BOOL bBlocked, LONG nVoiceTypeId);
	~CVaxUser();

private:

	static CVaxUserList* m_pUserList;
	static LONG m_nRegisterUserCount;

private:
			
	BOOL m_bRegistered;
	BOOL m_bBlocked;

	int m_nVoiceTypeId;	
	
private:

	void OnRegister(LPCTSTR sUserLogin, LONG nRegId);
	void OnRegisterSuccess(LPCTSTR sUserLogin);
	void OnRegisterFailed(LPCTSTR sUserLogin);
	void OnUnRegister(LPCTSTR sUserLogin);

public:

	static void OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgentName, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	static void OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	static void OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId);
	static void OnUnRegisterUser(LPCTSTR sUserLogin);

private:

	static CVaxUser* GetUser(LPCTSTR sUserName);

public:

	static void ResetAll(BOOL bAlloc, BOOL bDeAlloc);

	static BOOL AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sAudioCodecList, BOOL bBlocked, LONG nVoiceTypeId, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, LPCTSTR sToPeerName);
	static void RemoveUser(LPCTSTR sUserName);
	static void LoadUser();

	static BOOL IsUserTypeAdmin(LPCTSTR sUserName);
	static int GetVoiceTypeId(LPCTSTR sUserName);

	static LONG GetRegisteredUserCount();
};

