#include "stdafx.h"
#include "VaxUser.h"
#include "VaxUserList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CVaxUserList::CVaxUserList()
{
	m_pDataList = new CVaxHashText(1024);
}

CVaxUserList::~CVaxUserList()
{
	delete m_pDataList;
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

void CVaxUserList::AddUser(LPCTSTR sUserName, BOOL bBlocked, LONG nVoiceTypeId)
{
	m_pDataList->DeleteData(sUserName);
		
	CVaxUser* pUser = new CVaxUser(sUserName, bBlocked, nVoiceTypeId);
	m_pDataList->AddData(sUserName, pUser);
}

void CVaxUserList::RemoveUser(LPCTSTR sUserName)
{
	m_pDataList->DeleteData(sUserName);
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

CVaxUser* CVaxUserList::GetUser(LPCTSTR sUserName)
{
	return (CVaxUser*) m_pDataList->FindData(sUserName);
}

BOOL CVaxUserList::IsExist(LPCTSTR sUserName)
{
	return m_pDataList->IsExistData(sUserName);
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

void CVaxUserList::GetUserAll(CStringList& objList)
{
	m_pDataList->GetNameAll(objList);
}

void CVaxUserList::ClearAll()
{
	m_pDataList->DeleteAll();
}