#include "StdAfx.h"
#include "StoreRegistry.h"
#include "StoreCallPickUp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

#define SUB_KEY_BUFFER_SIZE				2048
#define CALL_PICKUP_GROUP_ROOT_PATH		"CallPickUpGroups\\"

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

BOOL CStoreCallPickUp::AddGroup(LPCTSTR sGroupName, CStringList& objMemberList)
{
	RemoveGroup(sGroupName);

	if(CString(sGroupName).IsEmpty())
		return FALSE;

    CString sKeyPath;
	sKeyPath.Format("%s%s", CALL_PICKUP_GROUP_ROOT_PATH, sGroupName);
	
	CStoreRegistry objStore;
	objStore.SetTEXT(sKeyPath, "CallPickUpGroupName", sGroupName);
		
	POSITION hPos = objMemberList.GetHeadPosition();

	while(hPos != NULL)
	{
		CString sMemberName = objMemberList.GetNext(hPos);
		CStoreCallPickUp::AddGroupMember(sGroupName, sMemberName);
	}

	return TRUE;
}

void CStoreCallPickUp::RemoveGroup(LPCTSTR sGroupName)
{
	if(CString(sGroupName).IsEmpty())
		return;

	CString sKeyPath;
	sKeyPath.Format("%s%s", CALL_PICKUP_GROUP_ROOT_PATH, sGroupName);

	CStoreRegistry objStore;
	objStore.DeleteSubKey(sKeyPath);
}

void CStoreCallPickUp::GetGroupNameAll(CStringList& objList)
{
	CString sKeyPath;
	sKeyPath = CALL_PICKUP_GROUP_ROOT_PATH;

	CStoreRegistry objStore;
	objStore.EnumSubKeys(sKeyPath, objList);	
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

BOOL CStoreCallPickUp::GetGroup(LPCTSTR sGroupName, CStringList& objMemberList)
{
	if(CString(sGroupName).IsEmpty())
		return FALSE;

	GetMemberNameAll(sGroupName, objMemberList);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

BOOL CStoreCallPickUp::AddGroupMember(LPCTSTR sGroupName, LPCTSTR sUserName)
{
	if(CString(sGroupName).IsEmpty() || CString(sUserName).IsEmpty())
		return FALSE;

	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", CALL_PICKUP_GROUP_ROOT_PATH, sGroupName, "\\", sUserName);

	CStoreRegistry objStore;
    objStore.SetTEXT(sKeyPath, "sUserName", sUserName);	

    return TRUE;
}

void CStoreCallPickUp::RemoveGroupMember(LPCTSTR sGroupName, LPCTSTR sUserName)
{
	if(CString(sGroupName).IsEmpty() || CString(sUserName).IsEmpty())
		return;

	CString sKeyPath;
	sKeyPath.Format("%s%s%s%s", CALL_PICKUP_GROUP_ROOT_PATH, sGroupName, "\\", sUserName);

	CStoreRegistry objStore;
	objStore.DeleteSubKey(sKeyPath);
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

void CStoreCallPickUp::GetMemberNameAll(LPCTSTR sGroupName, CStringList& objList)
{
	objList.RemoveAll();

	if(CString(sGroupName).IsEmpty())
		return;

	CString sKeyPath;
	sKeyPath.Format("%s%s", CALL_PICKUP_GROUP_ROOT_PATH, sGroupName);

	CStoreRegistry objStore;
	objStore.EnumSubKeys(sKeyPath, objList);
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

BOOL CStoreCallPickUp::IsDataStored()
{
	CStoreRegistry objStore;
	return objStore.IsKeyExist(CALL_PICKUP_GROUP_ROOT_PATH);
}