// VaxTeleServerAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "VaxTeleServerAppDlg.h"
#include "AddLineDlg.h"

#include "AddLoginDlg.h"
#include "GeneralDlg.h"

#include "StatusLogDlg.h"
#include "AddRoomDlg.h"

#include "QueueDlg.h"
#include "RingGroupDlg.h"
#include "CallPickUpDlg.h"


#ifdef _DEBUG
	#define new DEBUG_NEW
	#undef THIS_FILE
	static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////

// CVaxTeleServerAppDlg dialog

IMPLEMENT_DYNAMIC(CVaxTeleServerAppDlg, CMySheet)

CVaxTeleServerAppDlg* CVaxTeleServerAppDlg::m_pVaxTeleServerAppDlg = NULL;

CVaxTeleServerAppDlg::CVaxTeleServerAppDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CMySheet(nIDCaption, pParentWnd, iSelectPage)
{
}

CVaxTeleServerAppDlg::CVaxTeleServerAppDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CMySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_pVaxServerSIP = new CVaxServerSIP();

	CVaxTeleServerAppDlg::m_pVaxTeleServerAppDlg = this;
	
	m_psh.dwFlags |= PSH_NOAPPLYNOW;   // Lose the Apply Now button
	m_psh.dwFlags &= ~PSH_HASHELP;     // Lose the Help button
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	m_pAddLoginDlg			= new CAddLoginDlg();
	m_pGeneralDlg			= new CGeneralDlg();
	
	m_pAddLineDlg			= new CAddLineDlg();
	m_pAddConferenceDlg		= new CAddRoomDlg();
				
	m_pStatusLogDlg			= new CStatusLogDlg;
	m_pVaxServerSIP->m_pStatusLogDlg = m_pStatusLogDlg;

	m_pQueueDlg = new CQueueDlg();
	m_pRingGroupDlg = new CRingGroupDlg();
	m_pCallPickUpDlg = new CCallPickUpDlg();
	
	AddPage(m_pGeneralDlg);
	AddPage(m_pAddLoginDlg);

	AddPage(m_pAddLineDlg);
	AddPage(m_pAddConferenceDlg);

	AddPage(m_pQueueDlg);
	AddPage(m_pRingGroupDlg);
	AddPage(m_pCallPickUpDlg);
	
	AddPage(m_pStatusLogDlg);
}

CVaxTeleServerAppDlg::~CVaxTeleServerAppDlg()
{
	delete m_pAddLoginDlg;
	delete m_pGeneralDlg;

	delete m_pAddLineDlg;
	delete m_pAddConferenceDlg;

	delete m_pRingGroupDlg;
	delete m_pQueueDlg;
	delete m_pCallPickUpDlg;

	delete m_pStatusLogDlg;
	delete m_pVaxServerSIP;
}

BEGIN_MESSAGE_MAP(CVaxTeleServerAppDlg, CMySheet)
	//{{AFX_MSG_MAP(CVaxTeleServerAppDlg)
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_NCCREATE()
	ON_WM_CLOSE()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVaxTeleServerAppDlg message handlers

BOOL CVaxTeleServerAppDlg::OnInitDialog() 
{
	BOOL bResult = CMySheet::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	// Get size in RECT structure
	RECT rcVaxTeleServerAppDlg;
	GetWindowRect (&rcVaxTeleServerAppDlg);

	ScreenToClient (&rcVaxTeleServerAppDlg);

	// Decrease it's bottom's size
	rcVaxTeleServerAppDlg.bottom -= 12;

	// Apply new size to this CPropertySheet
	SetWindowPos(NULL, 0,0, rcVaxTeleServerAppDlg.right, rcVaxTeleServerAppDlg.bottom, SWP_SHOWWINDOW | SWP_NOMOVE);

	//
	((CButton*) GetDlgItem(IDOK))->ShowWindow(SW_HIDE);
	((CButton*) GetDlgItem(IDCANCEL))->ShowWindow(SW_HIDE);

	return bResult;
}

HCURSOR CVaxTeleServerAppDlg::OnQueryDragIcon() 
{
	return (HCURSOR) m_hIcon;
}


BOOL CVaxTeleServerAppDlg::OnNcCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (!CMySheet::OnNcCreate(lpCreateStruct))
		return FALSE;

	LONG dwStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
	::SetWindowLong(m_hWnd, GWL_STYLE, dwStyle | WS_MINIMIZEBOX);

	return TRUE;
}


void CVaxTeleServerAppDlg::OnClose()
{
	CMySheet::OnClose();
}
